'------------------------------------------------------------------------------
' <auto-generated>
'     This code was generated by Measurement Studio.
'     Runtime Version:2.0.50727.1433
'
'     Changes to this file may cause incorrect behavior and will be lost if
'     the code is regenerated.
' </auto-generated>
'------------------------------------------------------------------------------

Option Strict Off
Option Explicit On

Imports System
Imports System.Runtime.InteropServices
Namespace NationalInstruments.ModularInstruments.Interop

    Public Class niRFSA
        Inherits Object
        Implements System.IDisposable

        Private _handle As System.IntPtr

        Private _disposed As Boolean = True

        Private Const rfsaModule As String = "niRFSA.dll"

        '''''<summary>
        '''''
        '''''Creates a new session for the device and performs the following initialization actions:
        '''''
        '''''Creates a new instrument driver session to the RF vector signal analyzer, using the downconverter resource name you specify with resourceName.
        '''''Sends initialization commands to reset all hardware modules to a known state necessary for NI-RFSA operation.
        '''''
        '''''Note:Before initializing the RF vector signal analyzer, an IF digitizer module (and an LO source for the NI 5663 only) must be associated with the RF downconverter module in MAX. After association, pass the RF downconverter device name to this VI to initialize both modules. To change the digitizer and LO source associations, modify the downconverter Properties page in MAX, or use the niRFSA_InitWithOptions function to override the association specified in MAX. Refer to the NI RF Vector Signal                 Analyzers Getting Started Guide, installed at Start&#187;All Programs?National  Instruments&#187;NI-RFSA&#187;Documentation for information about MAX association.
        '''''Supported Devices: NI 5600/5601 (downconverter only mode), NI 5661/5663
        '''''</summary>
        '''''<param name="Resource_Name">
        '''''
        '''''resourceName
        '''''ViRsrc
        '''''Specifies the resource name of the device to initialize.
        '''''
        '''''Example #
        '''''Device Type
        '''''Syntax
        '''''1
        '''''myDAQmxDevice
        '''''NI-DAQmx device, device name =
        '''''               &quot;myDAQmxDevice&quot;
        '''''2
        '''''myLogicalName
        '''''IVI logical name, name =
        '''''                  &quot;myLogicalName&quot;
        '''''
        '''''For NI-DAQmx devices, the syntax is the device name specified in MAX, as shown in
        '''''            Example 1. Typical default names for NI-DAQmx devices in MAX are Dev1 or PXI1Slot2. You
        '''''            can rename an NI-DAQmx device by right-clicking on the name in MAX and entering a new
        '''''            name. You also can pass in the name of an IVI logical name configured with the IVI
        '''''            Configuration utility. For additional information, refer to the Installed Devices&#187;IVI topic of the
        '''''            Measurement &amp; Automation Explorer Help.
        '''''
        '''''Caution&#160;&#160;NI-DAQmx device names are not case-sensitive. However, all IVI logical names are case-sensitive. If you use an IVI logical name, verify the name is identical to the name shown in the IVI Configuration Utility.
        '''''    
        '''''</param>
        '''''<param name="ID_Query">
        '''''
        '''''IDQuery
        '''''ViBoolean
        '''''specifies whether NI-RFSA performs an ID query. When you perform an ID query, NI-RFSA verifies that the device you initialize is supported. 
        '''''                                            VI_TRUE (Yes)
        '''''
        '''''                    Perform an ID query. This value is the default.
        '''''
        '''''                                                            VI_FALSE (No)
        '''''
        '''''                    Do not perform an ID query.
        '''''
        '''''</param>
        '''''<param name="Reset">
        '''''
        '''''reset
        '''''ViBoolean
        '''''Specifies whether the NI-RFSA device is reset during the initialization procedure.
        '''''
        '''''VI_TRUE (Yes)The device is reset.
        '''''VI_FALSE (No)The device is not reset. This value is the default.
        '''''
        '''''</param>
        '''''<param name="Instrument_Handle">
        '''''
        '''''vi
        '''''ViSession
        '''''Identifies your instrument session.
        '''''
        '''''</param>
        Public Sub New(ByVal Resource_Name As String, ByVal ID_Query As Boolean, ByVal Reset As Boolean)
            MyBase.New()
            Dim pInvokeResult As Integer = PInvoke.init(Resource_Name, System.Convert.ToUInt16(ID_Query), System.Convert.ToUInt16(Reset), Me._handle)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Me._disposed = False
        End Sub

        '''''<summary>
        '''''    
        '''''Creates a new session for the device and performs the following initialization actions:
        '''''Creates a new instrument driver session to the RF vector signal analyzer, using the downconverter resource name you specify with resourceName.
        '''''Sends initialization commands to reset all hardware modules to a known state necessary for NI-RFSA operation.
        '''''
        '''''Supported Devices: NI 5600/5601 (downconverter only mode), NI 5661/5663
        '''''
        '''''</summary>
        '''''<param name="Resource_Name">
        '''''
        '''''resourceName
        '''''ViRsrc
        '''''Specifies the resource name of the device to initialize.
        '''''
        '''''Example #
        '''''Device Type
        '''''Syntax
        '''''1
        '''''myDAQmxDevice
        '''''NI-DAQmx device, device name =
        '''''               &quot;myDAQmxDevice&quot;
        '''''2
        '''''myLogicalName
        '''''IVI logical name, name =
        '''''                  &quot;myLogicalName&quot;
        '''''
        '''''For NI-DAQmx devices, the syntax is the device name specified in MAX, as shown in
        '''''            Example 1. Typical default names for NI-DAQmx devices in MAX are Dev1 or PXI1Slot2. You
        '''''            can rename an NI-DAQmx device by right-clicking on the name in MAX and entering a new
        '''''            name. You also can pass in the name of an IVI logical name configured with the IVI
        '''''            Configuration utility. For additional information, refer to the Installed Devices&#187;IVI topic of the
        '''''            Measurement &amp; Automation Explorer Help.
        '''''
        '''''Caution&#160;&#160;NI-DAQmx device names are not case-sensitive. However, all IVI logical names are case-sensitive. If you use an IVI logical name, verify the name is identical to the name shown in the IVI Configuration Utility.
        '''''
        '''''</param>
        '''''<param name="ID_Query">
        '''''
        '''''IDQuery
        '''''ViBoolean
        '''''specifies whether NI-RFSA performs an ID query. When you perform an ID query, NI-RFSA verifies that the device you initialize is supported. 
        '''''                                            VI_TRUE (Yes)
        '''''
        '''''                    Perform an ID query. This value is the default.
        '''''
        '''''                                                            VI_FALSE (No)
        '''''
        '''''                    Do not perform an ID query.
        '''''
        '''''</param>
        '''''<param name="Reset">
        '''''
        '''''reset
        '''''ViBoolean
        '''''Specifies whether the NI-RFSA device is reset during the initialization procedure.
        '''''
        '''''VI_TRUE (Yes)The device is reset.
        '''''VI_FALSE (No)The device is not reset. This value is the default.
        '''''
        '''''</param>
        '''''<param name="Option_String">
        '''''
        '''''optionString
        '''''ViConstString
        '''''Sets the initial value of certain attributes for the session. The following attributes are used in this parameter.
        '''''
        '''''Name
        '''''Attribute
        '''''RangeCheck
        '''''NIRFSA_ATTR_RANGE_CHECK
        '''''QueryInstrStatus
        '''''NIRFSA_ATTR_QUERY_INSTRUMENT_STATUS
        '''''Cache
        '''''NIRFSA_ATTR_CACHE
        '''''RecordCoercions
        '''''NIRFSA_ATTR_RECORD_COERCIONS
        '''''DriverSetup
        '''''NIRFSA_ATTR_DRIVER_SETUP
        '''''
        '''''The format of this string is, &quot;AttributeName=Value&quot; where AttributeName is the name of the attribute and Value is the value to which the attribute will be set.  To set multiple attributes, separate their assignments with a comma.
        '''''
        '''''Example Option String:
        '''''&quot;RangeCheck=1,QueryInstrStatus=0,Cache=1,DriverSetup=Digitizer:pxi1slot4&quot;.
        '''''
        '''''If you want to use the NI 5600/5601 with an external digitizer for downconverter-only mode, use the following DriverSetup string: DriverSetup=Digitizer:&lt;external&gt;.
        '''''
        '''''NI 5663&#8212;LO source&#8212;Specifies the resource name of the LO source to use for this session. If you want to use the NI&#160;5601 with an LO source other than the NI 5652, use the following DriverSetup tag:DriverSetup=LO:&lt;external&gt;.
        '''''
        '''''To specify multiple resources in the DriverSetup string, separate their assignments with a semicolon.
        '''''
        '''''</param>
        '''''<param name="Instrument_Handle">
        '''''
        '''''vi
        '''''ViSession
        '''''Identifies your instrument session.
        '''''
        '''''</param>
        Public Sub New(ByVal Resource_Name As String, ByVal ID_Query As Boolean, ByVal Reset As Boolean, ByVal Option_String As String)
            MyBase.New()
            Dim pInvokeResult As Integer = PInvoke.InitWithOptions(Resource_Name, System.Convert.ToUInt16(ID_Query), System.Convert.ToUInt16(Reset), Option_String, Me._handle)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Me._disposed = False
        End Sub

        '''''<summary>
        '''''
        '''''Configures whether the session acquires I/Q data or computes a power spectrum over the specified frequency range. 
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''
        '''''vi
        '''''ViSession
        '''''Identifies your instrument session. vi is obtained from the niRFSA_init or niRFSA_initWithOptions function and identifies a
        '''''            particular instrument session.  
        '''''
        '''''</param>
        '''''<param name="Acquisition_Type">
        '''''
        '''''acquisitionType
        '''''ViInt32
        '''''Configures the type of acquisition.
        '''''
        ''''' IQ
        '''''Configures the driver for I/Q acquisitions. This value is the default.
        '''''Spectrum
        '''''Configures the driver for spectrum acquisitions.
        '''''
        '''''</param>
        '''''<returns>
        '''''
        '''''status
        '''''ViStatus
        '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. Examine the status code from each call to an NI-RFSA function to determine if an error has occurred.
        '''''
        '''''To obtain a text description of the status code and additional information about the error condition, call the niRFSA_GetError function. To clear the error information from NI-RFSA, call the niRFSA_ClearError function.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value
        '''''Meaning
        '''''0
        '''''Success
        '''''Positive Values
        '''''Warnings
        '''''Negative Values
        '''''Errors
        '''''
        '''''</returns>
        Public Function ConfigureAcquisitionType(ByVal Acquisition_Type As Integer) As Integer
            Dim pInvokeResult As Integer = PInvoke.ConfigureAcquisitionType(Me._handle, Acquisition_Type)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''
        '''''Configures the reference level. The reference level represents the maximum expected power of an input RF signal.
        '''''
        '''''Supported Devices: NI 5600/5601 (downconverter only mode), NI 5661/5663
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''
        '''''vi
        '''''ViSession
        '''''Identifies your instrument session. vi is obtained from the niRFSA_init or niRFSA_initWithOptions function and identifies a
        '''''            particular instrument session.  
        '''''
        '''''</param>
        '''''<param name="Channel_List">
        '''''
        '''''channelList
        '''''ViConstString
        '''''Identifies which channels to apply settings. Use &quot;&quot; (an empty string) or VI_NULL to specify all channels.
        '''''
        '''''</param>
        '''''<param name="Reference_Level">
        '''''
        '''''referenceLevel
        '''''ViReal64
        '''''Specifies the expected total integrated power, in dBm, of the RF input signal.
        '''''
        '''''</param>
        '''''<returns>
        '''''
        '''''status
        '''''ViStatus
        '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. Examine the status code from each call to an NI-RFSA function to determine if an error has occurred.
        '''''
        '''''To obtain a text description of the status code and additional information about the error condition, call the niRFSA_GetError function. To clear the error information from NI-RFSA, call the niRFSA_ClearError function.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value
        '''''Meaning
        '''''0
        '''''Success
        '''''Positive Values
        '''''Warnings
        '''''Negative Values
        '''''Errors
        '''''
        '''''</returns>
        Public Function ConfigureReferenceLevel(ByVal Channel_List As String, ByVal Reference_Level As Double) As Integer
            Dim pInvokeResult As Integer = PInvoke.ConfigureReferenceLevel(Me._handle, Channel_List, Reference_Level)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''
        '''''Configures the carrier frequency of the RF vector signal analyzer hardware for an I/Q acquisition. The carrier frequency is the center frequency of the I/Q acquisition.
        '''''
        '''''Supported Devices: NI 5661/5663
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''
        '''''vi
        '''''ViSession
        '''''Identifies your instrument session. vi is obtained from the niRFSA_init or niRFSA_initWithOptions function and identifies a
        '''''            particular instrument session.  
        '''''
        '''''</param>
        '''''<param name="Channel_List">
        '''''
        '''''channelList
        '''''ViConstString
        '''''Identifies which channels to apply settings. Use &quot;&quot; (an empty string) or VI_NULL to specify all channels.
        '''''
        '''''</param>
        '''''<param name="Carrier_Frequency">
        '''''
        '''''carrierFrequency
        '''''ViReal64
        '''''Specifies the carrier frequency, in hertz (Hz), of the RF signal to acquire. The RF vector signal analyzer tunes to this frequency. NI-RFSA may coerce this value based on hardware settings and downconversion settings.
        '''''
        '''''NI-RFSA sets the NIRFSA_ATTR_IQ_CARRIER_FREQUENCY attribute to this value. Refer to the specifications document that shipped with your device for allowable frequency settings.
        '''''
        '''''</param>
        '''''<returns>
        '''''
        '''''status
        '''''ViStatus
        '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. Examine the status code from each call to an NI-RFSA function to determine if an error has occurred.
        '''''
        '''''To obtain a text description of the status code and additional information about the error condition, call the niRFSA_GetError function. To clear the error information from NI-RFSA, call the niRFSA_ClearError function.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value
        '''''Meaning
        '''''0
        '''''Success
        '''''Positive Values
        '''''Warnings
        '''''Negative Values
        '''''Errors
        '''''
        '''''</returns>
        Public Function ConfigureIQCarrierFrequency(ByVal Channel_List As String, ByVal Carrier_Frequency As Double) As Integer
            Dim pInvokeResult As Integer = PInvoke.ConfigureIQCarrierFrequency(Me._handle, Channel_List, Carrier_Frequency)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''
        '''''Configures the rate at which the device samples I/Q values. The utilized downconverter bandwidth is equal to the coerced iqRate times 0.8.
        '''''
        '''''NI 5661&#8212;You should not need to configure an iqRate higher than 25 Samples per second (S/s) because the NI 5600 RF downconverter bandwidth is 20 MHz. If you choose to configure a higher I/Q rate, you may see aliasing effects at negative frequencies because the IF frequency of the NI 5600 RF downconverter is 15 MHz.
        '''''NI 5663&#8212;Your maximum allowed instantaneous bandwidth depends on the I/Q carrier frequency you use. Refer to the NI 5601 RF downconverter overview for more information about instantaneous bandwidth.
        '''''Supported Devices: NI 5661/5663
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''
        '''''vi
        '''''ViSession
        '''''Identifies your instrument session. vi is obtained from the niRFSA_init or niRFSA_initWithOptions function and identifies a
        '''''            particular instrument session.  
        '''''
        '''''</param>
        '''''<param name="Channel_List">
        '''''
        '''''channelList
        '''''ViConstString
        '''''Identifies which channels to apply settings. Use &quot;&quot; (an empty string) or VI_NULL to specify all channels.
        '''''
        '''''</param>
        '''''<param name="IQ_Rate">
        '''''
        '''''iqRate
        '''''ViReal64
        '''''Specifies the I/Q rate for the acquisition. The value is expressed in samples per second (S/s).
        '''''
        '''''</param>
        '''''<returns>
        '''''
        '''''status
        '''''ViStatus
        '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. Examine the status code from each call to an NI-RFSA function to determine if an error has occurred.
        '''''
        '''''To obtain a text description of the status code and additional information about the error condition, call the niRFSA_GetError function. To clear the error information from NI-RFSA, call the niRFSA_ClearError function.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value
        '''''Meaning
        '''''0
        '''''Success
        '''''Positive Values
        '''''Warnings
        '''''Negative Values
        '''''Errors
        '''''
        '''''</returns>
        Public Function ConfigureIQRate(ByVal Channel_List As String, ByVal IQ_Rate As Double) As Integer
            Dim pInvokeResult As Integer = PInvoke.ConfigureIQRate(Me._handle, Channel_List, IQ_Rate)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''
        '''''Configures the number of samples in a finite acquisition or configures the device to continuously acquire samples.
        '''''If you configure the device for finite acquisition, it acquires the specified number of samples and then stops the acquisition. You can configure the device to acquire multiple records using the niRFSA_ConfigureNumberOfRecords function. Each record contains the number of samples specified in this function. The default number of records to acquire is 1.
        '''''
        '''''If you configure the device to continuously acquire samples, it continues acquiring data until you call the niRFSA_Abort function to abort the acquisition. The device stores data in onboard memory in a circular fashion. After the device fills the memory, it starts overwriting previously acquired data from the beginning of the memory buffer. Retrieve the samples as they are being acquired using the niRFSA fetch IQ functions to avoid overwriting data before you retrieve it.
        '''''
        '''''Supported Devices: NI 5661/5663
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''
        '''''vi
        '''''ViSession
        '''''Identifies your instrument session. vi is obtained from the niRFSA_init or niRFSA_initWithOptions function and identifies a
        '''''            particular instrument session.  
        '''''
        '''''</param>
        '''''<param name="Channel_List">
        '''''
        '''''channelList
        '''''ViConstString
        '''''Identifies which channels to apply settings. Use &quot;&quot; (an empty string) or VI_NULL to specify all channels.
        '''''
        '''''</param>
        '''''<param name="Number_of_Samples_Is_Finite">
        '''''
        '''''numberOfSamplesIsFinite
        '''''ViBoolean
        '''''Specifies whether to configure the device to acquire a finite number of samples or to acquire samples continuously.
        '''''
        '''''VI_TRUEThe device acquires a finite number of samples.
        '''''VI_FALSEThe device continuously acquires samples.
        '''''
        '''''</param>
        '''''<param name="Samples_Per_Record">
        '''''
        '''''samplesPerRecord
        '''''ViInt64
        '''''Specifies the number of samples per record if numberOfSamplesIsFinite is set to VI_TRUE.
        '''''
        '''''</param>
        '''''<returns>
        '''''
        '''''status
        '''''ViStatus
        '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. Examine the status code from each call to an NI-RFSA function to determine if an error has occurred.
        '''''
        '''''To obtain a text description of the status code and additional information about the error condition, call the niRFSA_GetError function. To clear the error information from NI-RFSA, call the niRFSA_ClearError function.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value
        '''''Meaning
        '''''0
        '''''Success
        '''''Positive Values
        '''''Warnings
        '''''Negative Values
        '''''Errors
        '''''
        '''''</returns>
        Public Function ConfigureNumberOfSamples(ByVal Channel_List As String, ByVal Number_of_Samples_Is_Finite As Boolean, ByVal Samples_Per_Record As System.Int64) As Integer
            Dim pInvokeResult As Integer = PInvoke.ConfigureNumberOfSamples(Me._handle, Channel_List, System.Convert.ToUInt16(Number_of_Samples_Is_Finite), Samples_Per_Record)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''
        '''''Configures the number of records in a finite acquisition or configures the device to continuously acquire records. You can only configure the device to acquire multiple records if the numberOfRecordsIsFinite parameter is set to VI_TRUE.
        '''''
        '''''If you configure the device to acquire records continuously, it continues acquiring records until you call the niRFSA_abort function to abort the acquisition. The device stores records in onboard memory in a circular fashion. Once the device fills the memory, it starts overwriting previously acquired records from the beginning of the memory buffer. Fetch the records as they are acquired to avoid overwritting data before you retrieve it.
        '''''
        '''''Supported Devices: NI 5661/5663
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''
        '''''vi
        '''''ViSession
        '''''Identifies your instrument session. vi is obtained from the niRFSA_init or niRFSA_initWithOptions function and identifies a
        '''''            particular instrument session.  
        '''''
        '''''</param>
        '''''<param name="Channel_List">
        '''''
        '''''channelList
        '''''ViConstString
        '''''Identifies which channels to apply settings. Use &quot;&quot; (an empty string) or VI_NULL to specify all channels.
        '''''
        '''''</param>
        '''''<param name="Number_of_Records_Is_Finite">
        '''''
        '''''numberOfRecordsIsFinite
        '''''ViBoolean
        '''''Specifies whether to configure the device to acquire a finite number of records or to acquire records continuously.
        '''''
        '''''VI_TRUEThe device acquires a finite number of records.
        '''''VI_FALSEThe device continuously acquires records.
        '''''
        '''''</param>
        '''''<param name="Number_of_Records">
        '''''
        '''''numberOfRecords
        '''''ViInt64
        '''''Specifies the number of records to acquire if numberOfRecordsIsFinite is set to VI_TRUE. The default number of records to acquire is 1.
        '''''
        '''''</param>
        '''''<returns>
        '''''
        '''''status
        '''''ViStatus
        '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. Examine the status code from each call to an NI-RFSA function to determine if an error has occurred.
        '''''
        '''''To obtain a text description of the status code and additional information about the error condition, call the niRFSA_GetError function. To clear the error information from NI-RFSA, call the niRFSA_ClearError function.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value
        '''''Meaning
        '''''0
        '''''Success
        '''''Positive Values
        '''''Warnings
        '''''Negative Values
        '''''Errors
        '''''
        '''''</returns>
        Public Function ConfigureNumberOfRecords(ByVal Channel_List As String, ByVal Number_of_Records_Is_Finite As Boolean, ByVal Number_of_Records As System.Int64) As Integer
            Dim pInvokeResult As Integer = PInvoke.ConfigureNumberOfRecords(Me._handle, Channel_List, System.Convert.ToUInt16(Number_of_Records_Is_Finite), Number_of_Records)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''
        '''''Configures the span and center frequency of the spectrum read by NI-RFSA. A spectrum acquisition consists of data surrounding the center frequency.
        '''''
        '''''Note:If you configure the spectrum span to a value larger than the instantaneous bandwidth of the device, NI-RFSA
        '''''            performs multiple acquisitions and combines them into a spectrum of the size you
        '''''            requested.
        '''''
        '''''Note:For the NI 5663, NI-RFSA does not support continuous acquisitions from frequency bands for which the instantaneous bandwidth differs. Refer to the NI 5601 RF Downconverter topic for more information about instantaneous bandwidth.
        '''''Supported Devices: NI 5600/5601 (downconverter only mode), NI 5661/5663
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''
        '''''vi
        '''''ViSession
        '''''Identifies your instrument session. vi is obtained from the niRFSA_init or niRFSA_initWithOptions function and identifies a
        '''''            particular instrument session.  
        '''''
        '''''</param>
        '''''<param name="Channel_List">
        '''''
        '''''channelList
        '''''ViConstString
        '''''Identifies which channels to apply settings. Use &quot;&quot; (an empty string) or VI_NULL to specify all channels.
        '''''
        '''''</param>
        '''''<param name="Center_Frequency">
        '''''
        '''''centerFrequency
        '''''ViReal64
        '''''Specifies the center frequency of a spectrum acquisition. The value is expressed in hertz (Hz). The NI-RFSA device you use determines the valid range. Refer to your device specifications document for more information about frequency range.
        '''''
        '''''</param>
        '''''<param name="Span">
        '''''
        '''''span
        '''''ViReal64
        '''''Specifies the span of a spectrum acquisition. The value is expressed in hertz (Hz).
        '''''
        '''''</param>
        '''''<returns>
        '''''
        '''''status
        '''''ViStatus
        '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. Examine the status code from each call to an NI-RFSA function to determine if an error has occurred.
        '''''
        '''''To obtain a text description of the status code and additional information about the error condition, call the niRFSA_GetError function. To clear the error information from NI-RFSA, call the niRFSA_ClearError function.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value
        '''''Meaning
        '''''0
        '''''Success
        '''''Positive Values
        '''''Warnings
        '''''Negative Values
        '''''Errors
        '''''
        '''''</returns>
        Public Function ConfigureSpectrumFrequencyCenterSpan(ByVal Channel_List As String, ByVal Center_Frequency As Double, ByVal Span As Double) As Integer
            Dim pInvokeResult As Integer = PInvoke.ConfigureSpectrumFrequencyCenterSpan(Me._handle, Channel_List, Center_Frequency, Span)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''
        '''''Configures the start and stop frequencies of the spectrum read by NI-RFSA.
        '''''
        '''''Note:If you configure the spectrum span (stopFrequency &#8211;
        '''''                startFrequency) to a value larger than the instantaneous bandwidth of the device, NI-RFSA
        '''''            performs multiple acquisitions and combines them into a spectrum of the size you
        '''''            request.
        '''''Supported Devices: NI 5600/5601 (downconverter only mode), NI 5661/5663
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''
        '''''vi
        '''''ViSession
        '''''Identifies your instrument session. vi is obtained from the niRFSA_init or niRFSA_initWithOptions function and identifies a
        '''''            particular instrument session.  
        '''''
        '''''</param>
        '''''<param name="Channel_List">
        '''''
        '''''channelList
        '''''ViConstString
        '''''Identifies which channels to apply settings. Use &quot;&quot; (an empty string) or VI_NULL to specify all channels.
        '''''
        '''''</param>
        '''''<param name="Start_Frequency">
        '''''
        '''''startFrequency
        '''''ViReal64
        '''''Specifies the lower limit of a span of frequencies. This value is expressed in hertz (Hz).
        '''''
        '''''</param>
        '''''<param name="Stop_Frequency">
        '''''
        '''''stopFrequency
        '''''ViReal64
        '''''Specifies the upper limit of a span of frequencies. This value is expressed in hertz (Hz).
        '''''
        '''''</param>
        '''''<returns>
        '''''
        '''''status
        '''''ViStatus
        '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. Examine the status code from each call to an NI-RFSA function to determine if an error has occurred.
        '''''
        '''''To obtain a text description of the status code and additional information about the error condition, call the niRFSA_GetError function. To clear the error information from NI-RFSA, call the niRFSA_ClearError function.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value
        '''''Meaning
        '''''0
        '''''Success
        '''''Positive Values
        '''''Warnings
        '''''Negative Values
        '''''Errors
        '''''
        '''''</returns>
        Public Function ConfigureSpectrumFrequencyStartStop(ByVal Channel_List As String, ByVal Start_Frequency As Double, ByVal Stop_Frequency As Double) As Integer
            Dim pInvokeResult As Integer = PInvoke.ConfigureSpectrumFrequencyStartStop(Me._handle, Channel_List, Start_Frequency, Stop_Frequency)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''
        '''''Configures the resolution bandwidth of a spectrum acquisition. The resolution bandwidth controls the width of the frequency bins in the power spectrum computed by NI-RFSA. A larger value for resolution bandwidth means the frequency bins are wider, and hence you get fewer bins, or spectral lines.
        '''''By default, the resolution bandwidth value corresponds to the 3&#160;decibels (dB) bandwidth of the window type NI-RFSA uses to compute the spectrum. To specify the frequency bin width directly, change the NIRFSA_ATTR_RESOLUTION_BANDWIDTH_TYPE attribute to NIRFSA_VAL_BIN_WIDTH.
        '''''Supported Devices: NI 5661/5663
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''
        '''''vi
        '''''ViSession
        '''''Identifies your instrument session. vi is obtained from the niRFSA_init or niRFSA_initWithOptions function and identifies a
        '''''            particular instrument session.  
        '''''
        '''''</param>
        '''''<param name="Channel_List">
        '''''
        '''''channelList
        '''''ViConstString
        '''''Identifies which channels to apply settings. Use &quot;&quot; (an empty string) or VI_NULL to specify all channels.
        '''''
        '''''</param>
        '''''<param name="Resolution_Bandwidth">
        '''''
        '''''resolutionBandwidth
        '''''ViReal64
        '''''Specifies the resolution bandwidth of a spectrum acquisition. The value is expressed in hertz (Hz). Configure the type of resolution bandwidth with the NIRFSA_ATTR_RESOLUTION_BANDWIDTH_TYPE attribute.
        '''''
        '''''</param>
        '''''<returns>
        '''''
        '''''status
        '''''ViStatus
        '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. Examine the status code from each call to an NI-RFSA function to determine if an error has occurred.
        '''''
        '''''To obtain a text description of the status code and additional information about the error condition, call the niRFSA_GetError function. To clear the error information from NI-RFSA, call the niRFSA_ClearError function.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value
        '''''Meaning
        '''''0
        '''''Success
        '''''Positive Values
        '''''Warnings
        '''''Negative Values
        '''''Errors
        '''''
        '''''</returns>
        Public Function ConfigureResolutionBandwidth(ByVal Channel_List As String, ByVal Resolution_Bandwidth As Double) As Integer
            Dim pInvokeResult As Integer = PInvoke.ConfigureResolutionBandwidth(Me._handle, Channel_List, Resolution_Bandwidth)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''
        '''''Configures the device to wait for a digital edge Start trigger at the beginning of the acquisition.
        '''''Supported Devices: NI 5661/5663
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''
        '''''vi
        '''''ViSession
        '''''Identifies your instrument session. vi is obtained from the niRFSA_init or niRFSA_initWithOptions function and identifies a
        '''''            particular instrument session.  
        '''''
        '''''</param>
        '''''<param name="Source">
        '''''
        '''''source
        '''''ViConstString
        '''''Specifies the source of the digital edge for the Start trigger.
        '''''
        '''''PFI0
        '''''The trigger is received on PFI 0.
        '''''PFI1
        '''''The trigger is received on PFI 1.
        '''''PXI_Trig0
        '''''The trigger is received on PXI trigger line 0.
        '''''PXI_Trig1
        '''''The trigger is received on PXI trigger line 1.
        '''''PXI_Trig2
        '''''The trigger is received on PXI trigger line 2.
        '''''PXI_Trig3
        '''''The trigger is received on PXI trigger line 3.
        '''''PXI_Trig4
        '''''The trigger is received on PXI trigger line 4.
        '''''PXI_Trig5
        '''''The trigger is received on PXI trigger line 5.
        '''''PXI_Trig6
        '''''The trigger is received on PXI trigger line 6.
        '''''PXI_Trig7
        '''''The trigger is received on PXI trigger line 7.
        '''''PXI_STAR
        '''''The trigger is received on the PXI star trigger line.
        '''''
        '''''</param>
        '''''<param name="Edge">
        '''''
        '''''edge
        '''''ViInt32
        '''''Specifies the edge to detect.
        '''''
        '''''Rising EdgeNI-RFSA detects a rising edge.
        '''''Falling EdgeNI-RFSA detects a falling edge.
        '''''
        '''''</param>
        '''''<returns>
        '''''
        '''''status
        '''''ViStatus
        '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. Examine the status code from each call to an NI-RFSA function to determine if an error has occurred.
        '''''
        '''''To obtain a text description of the status code and additional information about the error condition, call the niRFSA_GetError function. To clear the error information from NI-RFSA, call the niRFSA_ClearError function.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value
        '''''Meaning
        '''''0
        '''''Success
        '''''Positive Values
        '''''Warnings
        '''''Negative Values
        '''''Errors
        '''''
        '''''</returns>
        Public Function ConfigureDigitalEdgeStartTrigger(ByVal Source As String, ByVal Edge As Integer) As Integer
            Dim pInvokeResult As Integer = PInvoke.ConfigureDigitalEdgeStartTrigger(Me._handle, Source, Edge)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''
        '''''Configures the device to wait for a software Start trigger at the beginning of the acquisition. The device  waits until you call the niRFSA_SendSoftwareEdgeTrigger function to assert the trigger.
        '''''Supported Devices: NI 5661/5663
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''
        '''''vi
        '''''ViSession
        '''''Identifies your instrument session. vi is obtained from the niRFSA_init or niRFSA_initWithOptions function and identifies a
        '''''            particular instrument session.  
        '''''
        '''''</param>
        '''''<returns>
        '''''
        '''''status
        '''''ViStatus
        '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. Examine the status code from each call to an NI-RFSA function to determine if an error has occurred.
        '''''
        '''''To obtain a text description of the status code and additional information about the error condition, call the niRFSA_GetError function. To clear the error information from NI-RFSA, call the niRFSA_ClearError function.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value
        '''''Meaning
        '''''0
        '''''Success
        '''''Positive Values
        '''''Warnings
        '''''Negative Values
        '''''Errors
        '''''
        '''''</returns>
        Public Function ConfigureSoftwareEdgeStartTrigger() As Integer
            Dim pInvokeResult As Integer = PInvoke.ConfigureSoftwareEdgeStartTrigger(Me._handle)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''
        '''''Configures the device to not wait for a Start trigger at the beginning of the acquisition. This function is only necessary if you configured a Start trigger in the past and now want to disable it.
        '''''
        '''''Supported Devices: NI 5661/5663
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''
        '''''vi
        '''''ViSession
        '''''Identifies your instrument session. vi is obtained from the niRFSA_init or niRFSA_initWithOptions function and identifies a
        '''''            particular instrument session.  
        '''''
        '''''</param>
        '''''<returns>
        '''''
        '''''status
        '''''ViStatus
        '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. Examine the status code from each call to an NI-RFSA function to determine if an error has occurred.
        '''''
        '''''To obtain a text description of the status code and additional information about the error condition, call the niRFSA_GetError function. To clear the error information from NI-RFSA, call the niRFSA_ClearError function.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value
        '''''Meaning
        '''''0
        '''''Success
        '''''Positive Values
        '''''Warnings
        '''''Negative Values
        '''''Errors
        '''''
        '''''</returns>
        Public Function DisableStartTrigger() As Integer
            Dim pInvokeResult As Integer = PInvoke.DisableStartTrigger(Me._handle)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''
        '''''Configures the device to wait for a digital edge Reference trigger to mark a reference point within the record.
        '''''
        '''''Supported Devices: NI 5661/5663
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''
        '''''vi
        '''''ViSession
        '''''Identifies your instrument session. vi is obtained from the niRFSA_init or niRFSA_initWithOptions function and identifies a
        '''''            particular instrument session.  
        '''''
        '''''</param>
        '''''<param name="Source">
        '''''
        '''''source
        '''''ViConstString
        '''''Specifies the source of the digital edge for the Reference trigger.
        '''''
        ''''' NIRFSA_VAL_PFI0_STR  (&quot;PFI0&quot;)
        '''''The trigger is received on PFI 0.
        '''''NIRFSA_VAL_PFI1_STR  (&quot;PFI1&quot;)
        '''''The trigger is received on PFI 1.
        ''''' NIRFSA_VAL_PXI_TRIG0_STR (&quot;PXI_Trig0&quot;)
        '''''The trigger is received on PXI trigger line 0.
        ''''' NIRFSA_VAL_PXI_TRIG1_STR (&quot;PXI_Trig1&quot;)
        '''''The trigger is received on PXI trigger line 1.
        ''''' NIRFSA_VAL_PXI_TRIG2_STR (&quot;PXI_Trig2&quot;)
        '''''The trigger is received on PXI trigger line 2.
        ''''' NIRFSA_VAL_PXI_TRIG3_STR (&quot;PXI_Trig3&quot;)
        '''''The trigger is received on PXI trigger line 3.
        ''''' NIRFSA_VAL_PXI_TRIG4_STR (&quot;PXI_Trig4&quot;)
        '''''The trigger is received on PXI trigger line 4.
        ''''' NIRFSA_VAL_PXI_TRIG5_STR (&quot;PXI_Trig5&quot;)
        '''''The trigger is received on PXI trigger line 5.
        ''''' NIRFSA_VAL_PXI_TRIG6_STR (&quot;PXI_Trig6&quot;)
        '''''The trigger is received on PXI trigger line 6.
        ''''' NIRFSA_VAL_PXI_TRIG7_STR (&quot;PXI_Trig7&quot;)
        '''''The trigger is received on PXI trigger line 7.
        ''''' NIRFSA_VAL_PXI_STAR_STR (&quot;PXI_STAR&quot;)
        '''''The trigger is received on the PXI star trigger line.
        '''''
        '''''</param>
        '''''<param name="Edge">
        '''''
        '''''edge
        '''''ViInt32
        '''''Specifies the trigger edge to detect.
        '''''
        '''''NIRFSA_VAL_RISING_EDGE (900)NI-RFSA detects a rising edge.
        '''''NIRFSA_VAL_FALLING_EDGE (901)NI-RFSA detects a falling edge.
        '''''
        '''''</param>
        '''''<param name="Pretrigger_Samples">
        '''''
        '''''pretriggerSamples
        '''''ViInt64
        '''''Specifies the number of samples to store for each record that was acquired in the time period immediately before the trigger occurred. 
        '''''
        '''''</param>
        '''''<returns>
        '''''
        '''''status
        '''''ViStatus
        '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. Examine the status code from each call to an NI-RFSA function to determine if an error has occurred.
        '''''
        '''''To obtain a text description of the status code and additional information about the error condition, call the niRFSA_GetError function. To clear the error information from NI-RFSA, call the niRFSA_ClearError function.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value
        '''''Meaning
        '''''0
        '''''Success
        '''''Positive Values
        '''''Warnings
        '''''Negative Values
        '''''Errors
        '''''
        '''''</returns>
        Public Function ConfigureDigitalEdgeRefTrigger(ByVal Source As String, ByVal Edge As Integer, ByVal Pretrigger_Samples As System.Int64) As Integer
            Dim pInvokeResult As Integer = PInvoke.ConfigureDigitalEdgeRefTrigger(Me._handle, Source, Edge, Pretrigger_Samples)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''
        '''''Configures the device to wait for the complex power of the I/Q data to cross the specified threshold to mark a reference point within the record.
        '''''
        '''''To trigger on bursted signals, add a minimum quiet time (configured with the NIRFSA_ATTR_IQ_POWER_EDGE_REF_TRIGGER_MINIMUM_QUIET_TIME attribute) to ensure the trigger does not occur in the middle of a burst if the acquisition starts while a burst is being generated. The quiet time should be set to a value smaller than the time between bursts, but large enough to ignore power changes within a burst.
        '''''
        '''''Supported Devices: NI 5661/5663
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''
        '''''vi
        '''''ViSession
        '''''Identifies your instrument session. vi is obtained from the niRFSA_init or niRFSA_initWithOptions function and identifies a
        '''''            particular instrument session.  
        '''''
        '''''</param>
        '''''<param name="Source">
        '''''
        '''''source
        '''''ViConstString
        '''''Specifies the source of the RF signal for the power edge Reference trigger. The only supported value is channel &quot;0&quot;.
        '''''
        '''''</param>
        '''''<param name="Level">
        '''''
        '''''level
        '''''ViReal64
        '''''Specifies the threshold above or below which the device  triggers.
        '''''
        '''''</param>
        '''''<param name="Slope">
        '''''
        '''''slope
        '''''ViInt32
        '''''Specifies whether the device detects a positive or negative slope on the trigger signal.
        '''''
        '''''NIRFSA_VAL_RISING_SLOPE (1000)NI-RFSA detects a rising edge (positive slope). This value is the default.
        '''''NIRFSA_VAL_FALLING_SLOPE (1001)NI-RFSA detects a falling edge (negative slope).
        '''''
        '''''</param>
        '''''<param name="Pretrigger_Samples">
        '''''
        '''''pretriggerSamples
        '''''ViInt64
        '''''Specifies the number of samples to store for each record that was acquired in the time period immediately before the trigger occurred. 
        '''''
        '''''</param>
        '''''<returns>
        '''''
        '''''status
        '''''ViStatus
        '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. Examine the status code from each call to an NI-RFSA function to determine if an error has occurred.
        '''''
        '''''To obtain a text description of the status code and additional information about the error condition, call the niRFSA_GetError function. To clear the error information from NI-RFSA, call the niRFSA_ClearError function.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value
        '''''Meaning
        '''''0
        '''''Success
        '''''Positive Values
        '''''Warnings
        '''''Negative Values
        '''''Errors
        '''''
        '''''</returns>
        Public Function ConfigureIQPowerEdgeRefTrigger(ByVal Source As String, ByVal Level As Double, ByVal Slope As Integer, ByVal Pretrigger_Samples As System.Int64) As Integer
            Dim pInvokeResult As Integer = PInvoke.ConfigureIQPowerEdgeRefTrigger(Me._handle, Source, Level, Slope, Pretrigger_Samples)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''
        '''''Configures the device to wait for a software Reference trigger to mark a reference point within the record. The device waits until you call the niRFSA_SendSoftwareEdgeTrigger function to assert the trigger.
        '''''
        '''''Supported Devices: NI 5661/5663
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''
        '''''vi
        '''''ViSession
        '''''Identifies your instrument session. vi is obtained from the niRFSA_init or niRFSA_initWithOptions function and identifies a
        '''''            particular instrument session.  
        '''''
        '''''</param>
        '''''<param name="Pretrigger_Samples">
        '''''
        '''''pretriggerSamples
        '''''ViInt64
        '''''Specifies the number of samples to store for each record that was acquired in the time period immediately before the trigger occurred. 
        '''''
        '''''</param>
        '''''<returns>
        '''''
        '''''status
        '''''ViStatus
        '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. Examine the status code from each call to an NI-RFSA function to determine if an error has occurred.
        '''''
        '''''To obtain a text description of the status code and additional information about the error condition, call the niRFSA_GetError function. To clear the error information from NI-RFSA, call the niRFSA_ClearError function.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value
        '''''Meaning
        '''''0
        '''''Success
        '''''Positive Values
        '''''Warnings
        '''''Negative Values
        '''''Errors
        '''''
        '''''</returns>
        Public Function ConfigureSoftwareEdgeRefTrigger(ByVal Pretrigger_Samples As System.Int64) As Integer
            Dim pInvokeResult As Integer = PInvoke.ConfigureSoftwareEdgeRefTrigger(Me._handle, Pretrigger_Samples)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''
        '''''Configures the device to not wait for a Reference trigger to mark a reference point within a record. This function is only necessary if you configured a Reference trigger in the past and now want to disable it.
        '''''
        '''''Supported Devices: NI 5661/5663
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''
        '''''vi
        '''''ViSession
        '''''Identifies your instrument session. vi is obtained from the niRFSA_init or niRFSA_initWithOptions function and identifies a
        '''''            particular instrument session.  
        '''''
        '''''</param>
        '''''<returns>
        '''''
        '''''status
        '''''ViStatus
        '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. Examine the status code from each call to an NI-RFSA function to determine if an error has occurred.
        '''''
        '''''To obtain a text description of the status code and additional information about the error condition, call the niRFSA_GetError function. To clear the error information from NI-RFSA, call the niRFSA_ClearError function.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value
        '''''Meaning
        '''''0
        '''''Success
        '''''Positive Values
        '''''Warnings
        '''''Negative Values
        '''''Errors
        '''''
        '''''</returns>
        Public Function DisableRefTrigger() As Integer
            Dim pInvokeResult As Integer = PInvoke.DisableRefTrigger(Me._handle)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''
        '''''Configures the device to wait for a digital edge Advance trigger. The Advance trigger indicates where a new record begins.
        '''''
        '''''Supported Devices: NI 5661/5663
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''
        '''''vi
        '''''ViSession
        '''''Identifies your instrument session. vi is obtained from the niRFSA_init or niRFSA_initWithOptions function and identifies a
        '''''            particular instrument session.  
        '''''
        '''''</param>
        '''''<param name="Source">
        '''''
        '''''source
        '''''ViConstString
        '''''Specifies the source of the digital edge for the Advance trigger.
        '''''
        ''''' NIRFSA_VAL_PFI0_STR  (&quot;PFI0&quot;)
        '''''The trigger is received on PFI 0.
        '''''NIRFSA_VAL_PFI1_STR  (&quot;PFI1&quot;)
        '''''The trigger is received on PFI 1.
        ''''' NIRFSA_VAL_PXI_TRIG0_STR (&quot;PXI_Trig0&quot;)
        '''''The trigger is received on PXI trigger line 0.
        ''''' NIRFSA_VAL_PXI_TRIG1_STR (&quot;PXI_Trig1&quot;)
        '''''The trigger is received on PXI trigger line 1.
        ''''' NIRFSA_VAL_PXI_TRIG2_STR (&quot;PXI_Trig2&quot;)
        '''''The trigger is received on PXI trigger line 2.
        ''''' NIRFSA_VAL_PXI_TRIG3_STR (&quot;PXI_Trig3&quot;)
        '''''The trigger is received on PXI trigger line 3.
        ''''' NIRFSA_VAL_PXI_TRIG4_STR (&quot;PXI_Trig4&quot;)
        '''''The trigger is received on PXI trigger line 4.
        ''''' NIRFSA_VAL_PXI_TRIG5_STR (&quot;PXI_Trig5&quot;)
        '''''The trigger is received on PXI trigger line 5.
        ''''' NIRFSA_VAL_PXI_TRIG6_STR (&quot;PXI_Trig6&quot;)
        '''''The trigger is received on PXI trigger line 6.
        ''''' NIRFSA_VAL_PXI_TRIG7_STR (&quot;PXI_Trig7&quot;)
        '''''The trigger is received on PXI trigger line 7.
        ''''' NIRFSA_VAL_PXI_STAR_STR (&quot;PXI_STAR&quot;)
        '''''The trigger is received on the PXI star trigger line.
        '''''
        '''''</param>
        '''''<param name="Edge">
        '''''
        '''''edge
        '''''ViInt32
        '''''Specifies the trigger edge to detect.
        '''''
        '''''NIRFSA_VAL_RISING_EDGE (900)NI-RFSA detects a rising edge.
        '''''NIRFSA_VAL_FALLING_EDGE (901)NI-RFSA detects a falling edge.
        '''''
        '''''</param>
        '''''<returns>
        '''''
        '''''status
        '''''ViStatus
        '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. Examine the status code from each call to an NI-RFSA function to determine if an error has occurred.
        '''''
        '''''To obtain a text description of the status code and additional information about the error condition, call the niRFSA_GetError function. To clear the error information from NI-RFSA, call the niRFSA_ClearError function.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value
        '''''Meaning
        '''''0
        '''''Success
        '''''Positive Values
        '''''Warnings
        '''''Negative Values
        '''''Errors
        '''''
        '''''</returns>
        Public Function ConfigureDigitalEdgeAdvanceTrigger(ByVal Source As String, ByVal Edge As Integer) As Integer
            Dim pInvokeResult As Integer = PInvoke.ConfigureDigitalEdgeAdvanceTrigger(Me._handle, Source, Edge)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''
        '''''Configures the device to wait for a digital edge Advance trigger. The Advance trigger indicates where a new record begins. The device waits until you call the niRFSA_SendSoftwareEdgeTrigger function to assert the trigger.
        '''''
        '''''Supported Devices: NI 5661/5663
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''
        '''''vi
        '''''ViSession
        '''''Identifies your instrument session. vi is obtained from the niRFSA_init or niRFSA_initWithOptions function and identifies a
        '''''            particular instrument session.  
        '''''
        '''''</param>
        '''''<returns>
        '''''
        '''''status
        '''''ViStatus
        '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. Examine the status code from each call to an NI-RFSA function to determine if an error has occurred.
        '''''
        '''''To obtain a text description of the status code and additional information about the error condition, call the niRFSA_GetError function. To clear the error information from NI-RFSA, call the niRFSA_ClearError function.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value
        '''''Meaning
        '''''0
        '''''Success
        '''''Positive Values
        '''''Warnings
        '''''Negative Values
        '''''Errors
        '''''
        '''''</returns>
        Public Function ConfigureSoftwareEdgeAdvanceTrigger() As Integer
            Dim pInvokeResult As Integer = PInvoke.ConfigureSoftwareEdgeAdvanceTrigger(Me._handle)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''
        '''''Configures the device to not use an Advance trigger. This function is only necessary if you configured an Advance trigger in the past and now want to disable it.
        '''''
        '''''Supported Devices: NI 5661/5663
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''
        '''''vi
        '''''ViSession
        '''''Identifies your instrument session. vi is obtained from the niRFSA_init or niRFSA_initWithOptions function and identifies a
        '''''            particular instrument session.  
        '''''
        '''''</param>
        '''''<returns>
        '''''
        '''''status
        '''''ViStatus
        '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. Examine the status code from each call to an NI-RFSA function to determine if an error has occurred.
        '''''
        '''''To obtain a text description of the status code and additional information about the error condition, call the niRFSA_GetError function. To clear the error information from NI-RFSA, call the niRFSA_ClearError function.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value
        '''''Meaning
        '''''0
        '''''Success
        '''''Positive Values
        '''''Warnings
        '''''Negative Values
        '''''Errors
        '''''
        '''''</returns>
        Public Function DisableAdvanceTrigger() As Integer
            Dim pInvokeResult As Integer = PInvoke.DisableAdvanceTrigger(Me._handle)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''
        '''''Sends a trigger to the device when you configure a software version of a supported trigger and the device is waiting for the trigger to be sent. This function also can be used to override a hardware trigger.
        '''''This function returns an error in the following situations:
        '''''You configure an invalid trigger.
        '''''The instrument driver is in spectrum mode.
        '''''You have not previously called the niRFSA_Initiate function.
        '''''
        '''''Supported Devices: NI 5661/5663
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''
        '''''vi
        '''''ViSession
        '''''Identifies your instrument session. vi is obtained from the niRFSA_init or niRFSA_initWithOptions function and identifies a
        '''''            particular instrument session.  
        '''''
        '''''</param>
        '''''<param name="Trigger">
        '''''
        '''''trigger
        '''''ViInt32
        '''''Specifies the software signal to send.
        '''''
        '''''NIRFSA_VAL_START_TRIGGER (1100)NI-RFSA sends a Start software trigger.
        '''''NIRFSA_VAL_REF_TRIGGER (702)NI-RFSA sends a Reference software trigger.
        '''''NIRFSA_VAL_ADVANCE_TRIGGER (1102)NI-RFSA sends an Advance software trigger.
        '''''NIRFSA_VAL_ARM_REF_TRIGGER (1103)NI-RFSA sends an Arm Reference software trigger.
        '''''
        '''''</param>
        '''''<param name="Trigger_Identifier">
        '''''
        '''''triggerIdentifier
        '''''ViConstString
        '''''Specifies a particular instance of a trigger. NI-RFSA does not currently support this parameter.
        '''''
        '''''</param>
        '''''<returns>
        '''''
        '''''status
        '''''ViStatus
        '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. Examine the status code from each call to an NI-RFSA function to determine if an error has occurred.
        '''''
        '''''To obtain a text description of the status code and additional information about the error condition, call the niRFSA_GetError function. To clear the error information from NI-RFSA, call the niRFSA_ClearError function.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value
        '''''Meaning
        '''''0
        '''''Success
        '''''Positive Values
        '''''Warnings
        '''''Negative Values
        '''''Errors
        '''''
        '''''</returns>
        Public Function SendSoftwareEdgeTrigger(ByVal Trigger As Integer, ByVal Trigger_Identifier As String) As Integer
            Dim pInvokeResult As Integer = PInvoke.SendSoftwareEdgeTrigger(Me._handle, Trigger, Trigger_Identifier)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''
        '''''Routes signals (triggers, clocks, and events) to the specified output terminal.
        '''''
        '''''If you export a signal with this function and  commit the session, the signal is routed to the output terminal you specify. If you then reconfigure the signal to have a different output terminal, the previous output terminal is tristated when the session is next committed. If you change the outputTerminal to NIRFSA_VAL_DO_NOT_EXPORT and commit, the previous output terminal is tristated.
        '''''
        '''''Any signals, except for those exported over PXI trigger lines, that are exported within a session persist after the session closes to prevent signal glitches between sessions. PXI trigger lines are always set to tristate when a session is closed. If you wish to have the output terminal tristated when the session closes, first change the outputTerminal for the exported signal to NIRFSA_VAL_DO_NOT_EXPORT and commit the session again before closing it.
        '''''
        '''''You can also tristate all PFI lines by setting the resetDevice parameter in the niRFSA_init function or by using the niRFSA_reset function.
        '''''
        '''''Supported Devices: NI 5661/5663
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''
        '''''vi
        '''''ViSession
        '''''Identifies your instrument session. vi is obtained from the niRFSA_init or niRFSA_initWithOptions function and identifies a
        '''''            particular instrument session.  
        '''''
        '''''</param>
        '''''<param name="Signal">
        '''''
        '''''signal
        '''''ViInt32
        '''''Specifies the type of signal to route. You can choose to export the Start, Reference, and Advance triggers and the Ready for Start, Ready for Advance, Ready for Ref, End of Record, and Done events.
        '''''
        '''''NIRFSA_VAL_START_TRIGGER (1100)NI-RFSA routes a Start trigger signal.
        '''''NIRFSA_VAL_REF_TRIGGER (702)NI-RFSA routes a Reference trigger signal.
        '''''NIRFSA_VAL_ADVANCE_TRIGGER (1102)NI-RFSA routes an Advance trigger signal.
        '''''NIRFSA_VAL_READY_FOR_START_EVENT (1200)NI-RFSA routes a Ready for Start event signal.
        '''''NIRFSA_VAL_READY_FOR_ADVANCE_EVENT (1202)NI-RFSA routes a  Ready for Advance event signal.
        '''''NIRFSA_VAL_READY_FOR_REF_EVENT (1201)NI-RFSA routes a Ready for Reference event signal.
        '''''NIRFSA_VAL_END_OF_RECORD_EVENT (1203)NI-RFSA routes an End of Record event signal.
        '''''NIRFSA_VAL_DONE_EVENT (1204)NI-RFSA routes a Done event signal.
        '''''NIRFSA_VAL_REF_CLOCK (1205)NI-RFSA routes a Reference clock signal.
        '''''</param>
        '''''<param name="Signal_Identifier">
        '''''
        '''''signalIdentifier
        '''''ViConstString
        '''''Specifies a particular instance of a trigger. NI-RFSA does not currently support this parameter.
        '''''
        '''''</param>
        '''''<param name="Output_Terminal">
        '''''
        '''''outputTerminal
        '''''ViConstString
        '''''Specifies the terminal where the signal will be exported. You can also choose not to export any signal.
        '''''
        '''''</param>
        '''''<returns>
        '''''
        '''''status
        '''''ViStatus
        '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. Examine the status code from each call to an NI-RFSA function to determine if an error has occurred.
        '''''
        '''''To obtain a text description of the status code and additional information about the error condition, call the niRFSA_GetError function. To clear the error information from NI-RFSA, call the niRFSA_ClearError function.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value
        '''''Meaning
        '''''0
        '''''Success
        '''''Positive Values
        '''''Warnings
        '''''Negative Values
        '''''Errors
        '''''
        '''''</returns>
        Public Function ExportSignal(ByVal Signal As Integer, ByVal Signal_Identifier As String, ByVal Output_Terminal As String) As Integer
            Dim pInvokeResult As Integer = PInvoke.ExportSignal(Me._handle, Signal, Signal_Identifier, Output_Terminal)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''
        '''''Configures the NI-RFSA device Reference clock.
        '''''
        '''''Supported Devices: NI 5600/5601 (downconverter only mode), NI 5661/5663
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''
        '''''vi
        '''''ViSession
        '''''Identifies your instrument session. vi is obtained from the niRFSA_init or niRFSA_initWithOptions function and identifies a
        '''''            particular instrument session.  
        '''''
        '''''</param>
        '''''<param name="Ref_Clock_Source">
        '''''
        '''''refClockSource
        '''''ViConstString
        '''''Specifies the Reference clock source.
        '''''
        '''''NIRFSA_VAL_ONBOARD_CLOCK_STR (&quot;OnboardClock&quot;)
        '''''NI 5661&#8212;Lock the NI-RFSA device to the NI 5600 RF downconverter onboard clock.
        '''''
        '''''NI 5663&#8212;Lock the NI 5622 to the NI 5652 LO source onboard clock. Connect the REF IN/OUT connector on the NI 5652 to the CLK IN terminal on the NI 5622.
        '''''NIRFSA_VAL_REF_IN_STR (&quot;RefIn&quot;)
        '''''NI 5661&#8212;Lock the NI-RFSA device to the signal at the external FREQ REF IN connector on the
        '''''                  NI 5600.
        '''''
        '''''NI 5663&#8212;Connect the external signal to the NI&#160;5652 REF IN/OUT connector. Only use this configuration in downconverter-only mode.
        '''''NIRFSA_VAL_CLK_IN_STR (&quot;ClkIn&quot;)
        '''''NI 5661&#8212;This configuration does not apply to the NI 5661.
        '''''
        '''''NI 5663&#8212;Lock the NI 5622 to an external 10 MHz signal. Connect the external signal to the CLK IN connector on the NI 5622, and connect the NI 5622 CLK&#160;OUT connector to the REF IN/OUT connector on the NI 5652.
        '''''NIRFSA_VAL_PXI_CLK_STR (&quot;PXI_Clk&quot;)
        '''''NI 5661&#8212;Lock the NI-RFSA device to the PXI backplane clock using the NI&#160;5600. You must connect the PXI 10 MHz connector to the FREQ REF IN connector on the
        '''''                  NI&#160;5600 front panel to use this option.
        '''''
        '''''NI 5663&#8212;Lock the NI 5663 to the PXI backplane clock.
        '''''
        '''''</param>
        '''''<param name="Ref_Clock_Rate">
        '''''
        '''''refClockRate
        '''''ViReal64
        '''''Specifies the reference clock rate, expressed in hertz (Hz). The default value is 10 MHz, which is the only supported value.
        '''''
        '''''</param>
        '''''<returns>
        '''''
        '''''status
        '''''ViStatus
        '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. Examine the status code from each call to an NI-RFSA function to determine if an error has occurred.
        '''''
        '''''To obtain a text description of the status code and additional information about the error condition, call the niRFSA_GetError function. To clear the error information from NI-RFSA, call the niRFSA_ClearError function.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value
        '''''Meaning
        '''''0
        '''''Success
        '''''Positive Values
        '''''Warnings
        '''''Negative Values
        '''''Errors
        '''''
        '''''</returns>
        Public Function ConfigureRefClock(ByVal Ref_Clock_Source As String, ByVal Ref_Clock_Rate As Double) As Integer
            Dim pInvokeResult As Integer = PInvoke.ConfigureRefClock(Me._handle, Ref_Clock_Source, Ref_Clock_Rate)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''
        '''''Specifies the signal to drive the 10&#160;MHz Reference clock on the PXI backplane. This option can only be configured when the NI&#160;5600 is installed in Slot&#160;2 of the PXI chassis. 
        '''''
        '''''Supported Devices: NI 5600 (downconverter only mode), NI 5661
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''
        '''''vi
        '''''ViSession
        '''''Identifies your instrument session. vi is obtained from the niRFSA_init or niRFSA_initWithOptions function and identifies a
        '''''            particular instrument session.  
        '''''
        '''''</param>
        '''''<param name="PXI_Clk_10_Source">
        '''''
        '''''PXIClk10Source
        '''''ViConstString
        '''''Specifies the signal to drive the 10 MHz Reference clock on the PXI backplane. This option can only be configured when the NI&#160;5600 is in Slot&#160;2 of the PXI chassis. 
        '''''
        '''''                                                             NIRFSA_VAL_NONE_STR (&quot;None&quot;)
        '''''
        '''''                    The device does not drive the PXI 10 MHz backplane Reference
        '''''                  clock.
        '''''
        '''''                                                            NIRFSA_VAL_ONBOARD_CLOCK_STR (&quot;OnboardClock&quot;)
        '''''
        '''''                    The device drives the PXI 10 MHz backplane Reference clock with
        '''''                  the NI&#160;5600 onboard clock. You must connect the 10 MHz OUT connector to the
        '''''                  PXI 10 MHz I/O connector on the NI&#160;5600 front panel to use this option.
        '''''
        '''''                                                            NIRFSA_VAL_REF_IN_STR (&quot;RefIn&quot;)
        '''''
        '''''                    The device drives the PXI 10 MHz backplane Reference clock with
        '''''                  the reference source attached to the NI&#160;5600 FREQ REF IN connector. You must
        '''''                  connect the 10&#160;MHz&#160;OUT connector to the PXI&#160;10&#160;MHz&#160;I/O connector on the NI&#160;5600 front
        '''''                  panel to use this option.
        '''''
        '''''</param>
        '''''<returns>
        '''''
        '''''status
        '''''ViStatus
        '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. Examine the status code from each call to an NI-RFSA function to determine if an error has occurred.
        '''''
        '''''To obtain a text description of the status code and additional information about the error condition, call the niRFSA_GetError function. To clear the error information from NI-RFSA, call the niRFSA_ClearError function.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value
        '''''Meaning
        '''''0
        '''''Success
        '''''Positive Values
        '''''Warnings
        '''''Negative Values
        '''''Errors
        '''''
        '''''</returns>
        Public Function ConfigurePXIChassisClk10(ByVal PXI_Clk_10_Source As String) As Integer
            Dim pInvokeResult As Integer = PInvoke.ConfigurePXIChassisClk10(Me._handle, PXI_Clk_10_Source)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''
        '''''Resets the attribute to its default value.
        '''''
        '''''Supported Devices: 
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''
        '''''vi
        '''''ViSession
        '''''Identifies your instrument session. vi is obtained from the niRFSA_init or niRFSA_initWithOptions function and identifies a
        '''''            particular instrument session.  
        '''''
        '''''</param>
        '''''<param name="Channel_Name">
        '''''
        '''''channelName
        '''''ViConstString
        '''''Specifies the name of the channel on which to reset the attribute value if the attribute is channel based. If the attribute is not channel based, set this parameter to &quot;&quot; (empty string) or VI_NULL.
        '''''
        '''''</param>
        '''''<param name="Attribute_ID">
        '''''
        '''''attributeID
        '''''ViAttr
        '''''Pass the ID of an attribute.
        '''''
        '''''</param>
        '''''<returns>
        '''''
        '''''status
        '''''ViStatus
        '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. Examine the status code from each call to an NI-RFSA function to determine if an error has occurred.
        '''''
        '''''To obtain a text description of the status code and additional information about the error condition, call the niRFSA_GetError function. To clear the error information from NI-RFSA, call the niRFSA_ClearError function.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value
        '''''Meaning
        '''''0
        '''''Success
        '''''Positive Values
        '''''Warnings
        '''''Negative Values
        '''''Errors
        '''''
        '''''</returns>
        Public Function ResetAttribute(ByVal Channel_Name As String, ByVal Attribute_ID As Integer) As Integer
            Dim pInvokeResult As Integer = PInvoke.ResetAttribute(Me._handle, Channel_Name, Attribute_ID)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''
        '''''Starts an I/Q acquisition. You may use this function in conjunction with the NI-RFSA fetch IQ functions to retrieve acquired I/Q data, or use the NI-RFSA read IQ functions to both initiate the acquisition and retrieve I/Q data at one time.
        '''''
        '''''For improved accuracy, add a wait after calling the niRFSA_Commit function and before calling the niRFSA_Initiate function to allow the device additional settling time. Refer to the specifications document that shipped with your device for information about settling time and accuracy.
        '''''
        '''''Supported Devices: NI 5600/5601 (downconverter only mode), NI 5661/5663
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''
        '''''vi
        '''''ViSession
        '''''Identifies your instrument session. vi is obtained from the niRFSA_init or niRFSA_initWithOptions function and identifies a
        '''''            particular instrument session.  
        '''''
        '''''</param>
        '''''<returns>
        '''''
        '''''status
        '''''ViStatus
        '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. Examine the status code from each call to an NI-RFSA function to determine if an error has occurred.
        '''''
        '''''To obtain a text description of the status code and additional information about the error condition, call the niRFSA_GetError function. To clear the error information from NI-RFSA, call the niRFSA_ClearError function.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value
        '''''Meaning
        '''''0
        '''''Success
        '''''Positive Values
        '''''Warnings
        '''''Negative Values
        '''''Errors
        '''''
        '''''</returns>
        Public Function Initiate() As Integer
            Dim pInvokeResult As Integer = PInvoke.Initiate(Me._handle)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''
        '''''Fetches binary I/Q data from a single record in an acquisition. The fetch transfers acquired waveform data from device memory to computer memory. The data was acquired to onboard memory previously by the hardware after the acquisition was initiated.
        '''''
        '''''This function is not necessary if you use the niRFSA_ReadIQSingleRecordComplexF64 function, as a fetch is performed as part of that function.
        '''''
        '''''Supported Devices: NI 5661/5663
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''
        '''''vi
        '''''ViSession
        '''''Identifies your instrument session. vi is obtained from the niRFSA_init or niRFSA_initWithOptions function and identifies a
        '''''            particular instrument session.  
        '''''
        '''''</param>
        '''''<param name="Channel_List">
        '''''
        '''''channelList
        '''''ViConstString
        '''''Identifies which channels to apply settings. Use &quot;&quot; (an empty string) or VI_NULL to specify all channels.
        '''''
        '''''</param>
        '''''<param name="Record_Number">
        '''''
        '''''recordNumber
        '''''ViInt64
        '''''Specifies the record to retrieve. Record numbers are zero-based.
        '''''
        '''''</param>
        '''''<param name="Number_of_Samples">
        '''''
        '''''numberOfSamples
        '''''ViInt64
        '''''Specifies the number of samples to fetch. A value of &#8211;1 specifies that NI-RFSA will fetch all samples. The default value is 1000.
        '''''
        '''''</param>
        '''''<param name="Timeout">
        '''''
        '''''timeout
        '''''ViReal64
        '''''Specifies the time, in seconds, allotted for the function to complete before returning a timeout error. A value of &#8211;1 specifies the function waits until all data is available. A value of 0 specifies the function immediately returns available data. The default value is 10.
        '''''
        '''''</param>
        '''''<param name="Data">
        '''''
        '''''data
        '''''NIComplexI16*
        '''''Returns the acquired waveform. Allocate an NI ComplexI16 array at least as large as numberOfSamples.
        '''''
        '''''</param>
        '''''<param name="Waveform_Info">
        '''''
        '''''wfmInfo
        '''''niRFSA_wfmInfo*
        '''''Contains the absolute and relative timestamps for the operation, the time interval, and the actual number of samples read.
        '''''
        '''''The following list provides more information about each of these properties:
        '''''absolute timestamp&#8212;returns the timestamp, in seconds, of the first fetched sample that is comparable between records and acquisitions.
        '''''relative timestamp&#8212;returns a timestamp that corresponds to the difference, in seconds, between the first sample returned and the Reference trigger location.
        '''''dt&#8212;returns the time interval between data points in the acquired signal. The I/Q data sampling rate is the reciprocal of this value.
        '''''actual samples read&#8212;returns an integer representing the number of samples in the waveform.
        '''''offset&#8212;returns the offset to scale data (b) in mx+b form.
        '''''gain&#8212;returns the gain to scale data (m) in mx+b form.
        '''''
        '''''</param>
        '''''<returns>
        '''''
        '''''status
        '''''ViStatus
        '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. Examine the status code from each call to an NI-RFSA function to determine if an error has occurred.
        '''''
        '''''To obtain a text description of the status code and additional information about the error condition, call the niRFSA_GetError function. To clear the error information from NI-RFSA, call the niRFSA_ClearError function.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value
        '''''Meaning
        '''''0
        '''''Success
        '''''Positive Values
        '''''Warnings
        '''''Negative Values
        '''''Errors
        '''''
        '''''</returns>
        Public Function FetchIQSingleRecordComplexI16(ByVal Channel_List As String, ByVal Record_Number As System.Int64, ByVal Number_of_Samples As System.Int64, ByVal Timeout As Double, ByVal Data() As Short, ByRef Waveform_Info As niRFSA_wfmInfo) As Integer
            Dim pInvokeResult As Integer = PInvoke.FetchIQSingleRecordComplexI16(Me._handle, Channel_List, Record_Number, Number_of_Samples, Timeout, Data, Waveform_Info)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''
        '''''Fetches I/Q data from a single record in an acquisition. The fetch transfers acquired waveform data from device memory to computer memory. The data was acquired to onboard memory previously by the hardware after the acquisition was initiated.
        '''''
        '''''This function is not necessary if you use the niRFSA_ReadIQSingleRecordComplexF64 function, as the fetch is performed as part of that function.
        '''''
        '''''Supported Devices: NI 5661/5663
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''
        '''''vi
        '''''ViSession
        '''''Identifies your instrument session. vi is obtained from the niRFSA_init or niRFSA_initWithOptions function and identifies a
        '''''            particular instrument session.  
        '''''
        '''''</param>
        '''''<param name="Channel_List">
        '''''
        '''''channelList
        '''''ViConstString
        '''''Identifies which channels to apply settings. Use &quot;&quot; (an empty string) or VI_NULL to specify all channels.
        '''''
        '''''</param>
        '''''<param name="Record_Number">
        '''''
        '''''recordNumber
        '''''ViInt64
        '''''Specifies the record to retrieve. Record numbers are zero-based.
        '''''
        '''''</param>
        '''''<param name="Number_of_Samples">
        '''''
        '''''numberOfSamples
        '''''ViInt64
        '''''Specifies the number of samples to fetch.
        '''''
        '''''</param>
        '''''<param name="Timeout">
        '''''
        '''''timeout
        '''''ViReal64
        '''''Specifies the time, in seconds, allotted for the function to complete before returning a timeout error. A value of &#8211;1 specifies the function waits until all data is available. A value of 0 specifies the function immediately returns available data. The default value is 10.
        '''''
        '''''</param>
        '''''<param name="Data">
        '''''
        '''''data
        '''''NIComplexNumber*
        '''''Returns the acquired waveform. Allocate an NIComplexNumber array at least as large as numberOfSamples.
        '''''
        '''''</param>
        '''''<param name="Waveform_Info">
        '''''
        '''''wfmInfo
        '''''niRFSA_wfmInfo*
        '''''Returns the absolute and relative timestamps for the operation, the time interval, and the actual number of samples read.
        '''''
        '''''The following list provides more information about each of these properties:
        '''''absolute timestamp&#8212;returns the timestamp, in seconds, of the first fetched sample that is comparable between records and acquisitions.
        '''''relative timestamp&#8212;returns a timestamp that corresponds to the difference, in seconds, between the first sample returned and the Reference trigger location.
        '''''dt&#8212;returns the time interval between data points in the acquired signal. The I/Q data sampling rate is the reciprocal of this value.
        '''''actual samples read&#8212;returns an integer representing the number of samples in the waveform.
        '''''offset&#8212;returns the offset to scale data (b) in mx+b form.
        '''''gain&#8212;returns the gain to scale data (m) in mx+b form.
        '''''
        '''''</param>
        '''''<returns>
        '''''
        '''''status
        '''''ViStatus
        '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. Examine the status code from each call to an NI-RFSA function to determine if an error has occurred.
        '''''
        '''''To obtain a text description of the status code and additional information about the error condition, call the niRFSA_GetError function. To clear the error information from NI-RFSA, call the niRFSA_ClearError function.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value
        '''''Meaning
        '''''0
        '''''Success
        '''''Positive Values
        '''''Warnings
        '''''Negative Values
        '''''Errors
        '''''
        '''''</returns>
        Public Function FetchIQSingleRecordComplexF64(ByVal Channel_List As String, ByVal Record_Number As System.Int64, ByVal Number_of_Samples As System.Int64, ByVal Timeout As Double, ByVal Data() As niComplexNumber, ByRef Waveform_Info As niRFSA_wfmInfo) As Integer
            Dim pInvokeResult As Integer = PInvoke.FetchIQSingleRecordComplexF64(Me._handle, Channel_List, Record_Number, Number_of_Samples, Timeout, Data, Waveform_Info)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''
        '''''Initiates an acquisition and fetches a single I/Q data record. Do not use this function if you have configured the device to continuously acquire data samples or to acquire multiple records.
        '''''
        '''''Supported Devices: NI 5661/5663
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''
        '''''vi
        '''''ViSession
        '''''Identifies your instrument session. vi is obtained from the niRFSA_init or niRFSA_initWithOptions function and identifies a
        '''''            particular instrument session.  
        '''''
        '''''</param>
        '''''<param name="Channel_List">
        '''''
        '''''channelList
        '''''ViConstString
        '''''Identifies which channels to apply settings. Use &quot;&quot; (an empty string) or VI_NULL to specify all channels.
        '''''
        '''''</param>
        '''''<param name="Timeout">
        '''''
        '''''timeout
        '''''ViReal64
        '''''Specifies in seconds the time allotted for the function to complete before returning a timeout error. A value of &#8211;1 specifies the function waits until all data is available.
        '''''
        '''''</param>
        '''''<param name="Data">
        '''''
        '''''data
        '''''NIComplexNumber*
        '''''Returns the acquired waveform. Allocate an NIComplexNumber array at least as large as numberOfSamples.
        '''''
        '''''</param>
        '''''<param name="Data_Array_Size">
        '''''
        '''''dataArraySize
        '''''ViInt64
        '''''Specifies the size of the array for the data parameter. The array needs to be at least as large as the number of samples configured in the niRFSA_ConfigureNumberOfSamples function.
        '''''
        '''''</param>
        '''''<param name="Waveform_Info">
        '''''
        '''''wfmInfo*
        '''''niRFSA_wfmInfo
        '''''Returns additional information about the data array.
        '''''
        '''''The following list provides more information about each of these properties:
        '''''absolute timestamp&#8212;returns the timestamp, in seconds, of the first fetched sample that is comparable between records and acquisitions.
        '''''relative timestamp&#8212;returns a timestamp that corresponds to the difference, in seconds, between the first sample returned and the Reference trigger location.
        '''''dt&#8212;returns the time interval between data points in the acquired signal. The I/Q data sampling rate is the reciprocal of this value.
        '''''actual samples read&#8212;returns an integer representing the number of samples in the waveform.
        '''''offset&#8212;returns the offset to scale data (b) in mx+b form.
        '''''gain&#8212;returns the gain to scale data (m) in mx+b form.
        '''''
        '''''</param>
        '''''<returns>
        '''''
        '''''status
        '''''ViStatus
        '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. Examine the status code from each call to an NI-RFSA function to determine if an error has occurred.
        '''''
        '''''To obtain a text description of the status code and additional information about the error condition, call the niRFSA_GetError function. To clear the error information from NI-RFSA, call the niRFSA_ClearError function.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value
        '''''Meaning
        '''''0
        '''''Success
        '''''Positive Values
        '''''Warnings
        '''''Negative Values
        '''''Errors
        '''''
        '''''</returns>
        Public Function ReadIQSingleRecordComplexF64(ByVal Channel_List As String, ByVal Timeout As Double, ByVal Data() As niComplexNumber, ByVal Data_Array_Size As System.Int64, ByRef Waveform_Info As niRFSA_wfmInfo) As Integer
            Dim pInvokeResult As Integer = PInvoke.ReadIQSingleRecordComplexF64(Me._handle, Channel_List, Timeout, Data, Data_Array_Size, Waveform_Info)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''
        '''''Fetches binary I/Q data from multiple records in an acquisition. Fetching transfers acquired waveform data from device memory to computer memory. The data was acquired to onboard memory previously by the hardware after the acquisition was initiated.
        '''''
        '''''This function is not necessary if you use the niRFSA_ReadIQSingleRecordComplexF64 function, as the fetch is performed as part of that function.
        '''''
        '''''Supported Devices: NI 5661/5663
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''
        '''''vi
        '''''ViSession
        '''''Identifies your instrument session. vi is obtained from the niRFSA_init or niRFSA_initWithOptions function and identifies a
        '''''            particular instrument session.  
        '''''
        '''''</param>
        '''''<param name="Channel_List">
        '''''
        '''''channelList
        '''''ViConstString
        '''''Identifies which channels to apply settings. Use &quot;&quot; (an empty string) or VI_NULL to specify all channels.
        '''''
        '''''</param>
        '''''<param name="Starting_Record">
        '''''
        '''''startingRecord
        '''''ViInt64
        '''''Specifies the first record to retrieve. Record numbers are zero-based.
        '''''
        '''''</param>
        '''''<param name="Number_of_Records">
        '''''
        '''''numberOfRecords
        '''''ViInt64
        '''''Specifies the number of records to fetch. A value of &#8211;1 specifies that NI-RFSA fetches all records in an acquisition starting with the record specified by startingRecord. Record numbers are zero-based. The default value is &#8211;1.
        '''''
        '''''</param>
        '''''<param name="Number_of_Samples">
        '''''
        '''''numberofSamples
        '''''ViInt64
        '''''Specifies the number of samples per record.
        '''''</param>
        '''''<param name="Timeout">
        '''''
        '''''timeout
        '''''ViReal64
        '''''Specifies the time, in seconds, allotted for the function to complete before returning a timeout error. A value of &#8211;1 specifies the function waits until all data is available. A value of 0 specifies the function immediately returns available data. The default value is 10.
        '''''
        '''''</param>
        '''''<param name="Data">
        '''''
        '''''data
        '''''NIComplexI16*
        '''''Returns the acquired waveform for each record fetched. The waveforms are written sequentially in the array. Allocate an array at least as large as numberOfSamples times numberOfRecords for this parameter.
        '''''
        '''''</param>
        '''''<param name="Waveform_Info">
        '''''
        '''''wfmInfo
        '''''niRFSA_wfmInfo*
        '''''Returns an array of structures containing information about each record fetched. Each structure contains the absolute and relative timestamps, the dt, and the actual number of samples read for the corresponding record.
        '''''
        '''''The following list provides more information about each of these properties:
        '''''absolute timestamp&#8212;returns the timestamp in seconds of the first fetched sample that is comparable between records and acquisitions.
        '''''relative timestamp&#8212;returns a timestamp that corresponds to the difference in seconds between the first sample returned and the Reference trigger location.
        '''''dt&#8212;returns the time interval between data points in the acquired signal. The IQ data sampling rate is the reciprocal of this value.
        '''''actual samples read&#8212;returns an integer representing the number of samples in the waveform.
        '''''offset&#8212;returns the offset to scale data in mx+b form.
        '''''gain&#8212;returns the gain to scale data in mx+b form.
        '''''Note:Allocate an array of structures at least as large as numberOfRecords for this parameter.
        '''''
        '''''</param>
        '''''<returns>
        '''''
        '''''status
        '''''ViStatus
        '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. Examine the status code from each call to an NI-RFSA function to determine if an error has occurred.
        '''''
        '''''To obtain a text description of the status code and additional information about the error condition, call the niRFSA_GetError function. To clear the error information from NI-RFSA, call the niRFSA_ClearError function.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value
        '''''Meaning
        '''''0
        '''''Success
        '''''Positive Values
        '''''Warnings
        '''''Negative Values
        '''''Errors
        '''''
        '''''</returns>
        Public Function FetchIQMultiRecordComplexI16(ByVal Channel_List As String, ByVal Starting_Record As System.Int64, ByVal Number_of_Records As System.Int64, ByVal Number_of_Samples As System.Int64, ByVal Timeout As Double, ByVal Data() As Short, ByRef Waveform_Info As niRFSA_wfmInfo) As Integer
            Dim pInvokeResult As Integer = PInvoke.FetchIQMultiRecordComplexI16(Me._handle, Channel_List, Starting_Record, Number_of_Records, Number_of_Samples, Timeout, Data, Waveform_Info)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''
        '''''Fetches I/Q data from multiple records in an acquisition. A fetch transfers acquired waveform data from device memory to computer memory. The data was acquired to onboard memory previously by the hardware after the acquisition was initiated.
        '''''
        '''''This function is not necessary if you use the niRFSA_ReadIQSingleRecordComplexF64 function, as the fetch is performed as part of that function.
        '''''
        '''''Supported Devices: NI 5661/5663
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''
        '''''vi
        '''''ViSession
        '''''Identifies your instrument session. vi is obtained from the niRFSA_init or niRFSA_initWithOptions function and identifies a
        '''''            particular instrument session.  
        '''''
        '''''</param>
        '''''<param name="Channel_List">
        '''''
        '''''channelList
        '''''ViConstString
        '''''Identifies which channels to apply settings. Use &quot;&quot; (an empty string) or VI_NULL to specify all channels.
        '''''
        '''''</param>
        '''''<param name="Starting_Record">
        '''''
        '''''startingRecord
        '''''ViInt64
        '''''Specifies the first record to retrieve. Record numbers are zero-based.
        '''''
        '''''</param>
        '''''<param name="Number_of_Records">
        '''''
        '''''numberOfRecords
        '''''ViInt64
        '''''Specifies the number of records to fetch. A value of &#8211;1 specifies that NI-RFSA fetches all records in an acquisition starting with the record specified by startingRecord. Record numbers are zero-based.  The default value is &#8211;1.
        '''''
        '''''</param>
        '''''<param name="Number_of_Samples">
        '''''
        '''''numberOfSamples
        '''''ViInt64
        '''''Specifies the number of samples per record.
        '''''
        '''''</param>
        '''''<param name="Timeout">
        '''''
        '''''timeout
        '''''ViReal64
        '''''Specifies the time, in seconds, allotted for the function to complete before returning a timeout error. A value of &#8211;1 specifies the function waits until all data is available. A value of 0 specifies the function immediately returns available data. The default value is 10.
        '''''
        '''''</param>
        '''''<param name="Data">
        '''''
        '''''data
        '''''NIComplexNumber*
        '''''Returns the acquired waveform for each record fetched. The waveforms are written sequentially in the array. Allocate an array at least as large as numberOfSamples times numberOfRecords for this parameter.
        '''''
        '''''</param>
        '''''<param name="Waveform_Info">
        '''''
        '''''wfmInfo
        '''''niRFSA_wfmInfo*
        '''''Returns an array of structures containing information about each record fetched. Each structure contains the absolute and relative timestamps, the dt, and the actual number of samples read for the corresponding record.
        '''''
        '''''The following list provides more information about each of these properties:
        '''''absolute timestamp&#8212;returns the timestamp in seconds of the first fetched sample that is comparable between records and acquisitions.
        '''''relative timestamp&#8212;returns a timestamp that corresponds to the difference in seconds between the first sample returned and the Reference trigger location.
        '''''dt&#8212;returns the time interval between data points in the acquired signal. The IQ data sampling rate is the reciprocal of this value.
        '''''actual samples read&#8212;returns an integer representing the number of samples in the waveform.
        '''''offset&#8212;returns the offset to scale data in mx+b form.
        '''''gain&#8212;returns the gain to scale data in mx+b form.
        '''''Note:Allocate an array of structures at least as large as numberOfRecords for this parameter.
        '''''
        '''''</param>
        '''''<returns>
        '''''
        '''''status
        '''''ViStatus
        '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. Examine the status code from each call to an NI-RFSA function to determine if an error has occurred.
        '''''
        '''''To obtain a text description of the status code and additional information about the error condition, call the niRFSA_GetError function. To clear the error information from NI-RFSA, call the niRFSA_ClearError function.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value
        '''''Meaning
        '''''0
        '''''Success
        '''''Positive Values
        '''''Warnings
        '''''Negative Values
        '''''Errors
        '''''
        '''''</returns>
        Public Function FetchIQMultiRecordComplexF64(ByVal Channel_List As String, ByVal Starting_Record As System.Int64, ByVal Number_of_Records As System.Int64, ByVal Number_of_Samples As System.Int64, ByVal Timeout As Double, ByVal Data() As niComplexNumber, ByRef Waveform_Info As niRFSA_wfmInfo) As Integer
            Dim pInvokeResult As Integer = PInvoke.FetchIQMultiRecordComplexF64(Me._handle, Channel_List, Starting_Record, Number_of_Records, Number_of_Samples, Timeout, Data, Waveform_Info)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''
        '''''Stops an acquisition previously started with the niRFSA_Initiate function. Calling this function is optional, unless you want to stop an acquisition before it is complete or you are continuously acquiring data.
        '''''
        '''''Supported Devices: NI 5661/5663
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''
        '''''vi
        '''''ViSession
        '''''Identifies your instrument session. vi is obtained from the niRFSA_init or niRFSA_initWithOptions function and identifies a
        '''''            particular instrument session.  
        '''''
        '''''</param>
        '''''<returns>
        '''''
        '''''status
        '''''ViStatus
        '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. Examine the status code from each call to an NI-RFSA function to determine if an error has occurred.
        '''''
        '''''To obtain a text description of the status code and additional information about the error condition, call the niRFSA_GetError function. To clear the error information from NI-RFSA, call the niRFSA_ClearError function.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value
        '''''Meaning
        '''''0
        '''''Success
        '''''Positive Values
        '''''Warnings
        '''''Negative Values
        '''''Errors
        '''''
        '''''</returns>
        Public Function Abort() As Integer
            Dim pInvokeResult As Integer = PInvoke.Abort(Me._handle)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''
        '''''Initiates a spectrum acquisition and returns power spectrum data.
        '''''
        '''''Supported Devices: NI 5661/5663
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''
        '''''vi
        '''''ViSession
        '''''Identifies your instrument session. vi is obtained from the niRFSA_init or niRFSA_initWithOptions function and identifies a
        '''''            particular instrument session.  
        '''''
        '''''</param>
        '''''<param name="Channel_List">
        '''''
        '''''channelList
        '''''ViConstString
        '''''Identifies which channels to apply settings. Use &quot;&quot; (an empty string) or VI_NULL to specify all channels.
        '''''
        '''''</param>
        '''''<param name="Timeout">
        '''''
        '''''timeout
        '''''ViReal64
        '''''Specifies the time, in seconds, allotted for the function to complete before returning a timeout error. A value of &#8211;1 specifies the function waits until all data is available. The default value is 10.
        '''''
        '''''</param>
        '''''<param name="Power_Spectrum_Data">
        '''''
        '''''powerSpectrumData[]
        '''''ViReal64
        '''''Returns power spectrum data. Allocate an array as large as dataArraySize.
        '''''
        '''''</param>
        '''''<param name="Data_Array_Size">
        '''''
        '''''dataArraySize
        '''''ViInt64
        '''''Specifies the size of the array you specify for the powerSpectrumData parameter. Use the niRFSA_GetNumberOfSpectralLines function to obtain the array size to allocate. The array must be at least as large as the number of spectral lines that NI-RFSA computes for the power spectrum.
        '''''
        '''''</param>
        '''''<param name="Spectrum_Info">
        '''''
        '''''spectrumInfo
        '''''niRFSA_spectrumInfo*
        '''''Returns additional information about the powerSpectrumData array. This information includes the frequency, in hertz (Hz) corresponding to the first element in the array, the frequency increment, in Hz, between adjacent array elements, and the number of spectral lines the function returned.
        '''''
        '''''</param>
        '''''<returns>
        '''''
        '''''status
        '''''ViStatus
        '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. Examine the status code from each call to an NI-RFSA function to determine if an error has occurred.
        '''''
        '''''To obtain a text description of the status code and additional information about the error condition, call the niRFSA_GetError function. To clear the error information from NI-RFSA, call the niRFSA_ClearError function.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value
        '''''Meaning
        '''''0
        '''''Success
        '''''Positive Values
        '''''Warnings
        '''''Negative Values
        '''''Errors
        '''''
        '''''</returns>
        Public Function ReadPowerSpectrumF64(ByVal Channel_List As String, ByVal Timeout As Double, ByVal Power_Spectrum_Data() As Double, ByVal Data_Array_Size As Integer, ByRef Spectrum_Info As niRFSA_spectrumInfo) As Integer
            Dim pInvokeResult As Integer = PInvoke.ReadPowerSpectrumF64(Me._handle, Channel_List, Timeout, Power_Spectrum_Data, Data_Array_Size, Spectrum_Info)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''
        '''''Returns the number of spectral lines that NI-RFSA will compute with the current power spectrum configuration.
        '''''
        '''''Supported Devices: NI 5600/5601 (downconverter only mode), NI 5661/5663 
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''
        '''''vi
        '''''ViSession
        '''''Identifies your instrument session. vi is obtained from the niRFSA_init or niRFSA_initWithOptions function and identifies a
        '''''            particular instrument session.  
        '''''
        '''''</param>
        '''''<param name="Channel_List">
        '''''
        '''''channelList
        '''''ViConstString
        '''''Identifies which channels to apply settings. Use &quot;&quot; (an empty string) or VI_NULL to specify all channels.
        '''''
        '''''</param>
        '''''<param name="Number_of_Spectral_Lines">
        '''''
        '''''numberOfSpectralLines
        '''''ViInt32*
        '''''Returns the value of the NIRFSA_ATTR_NUM_SPECTRAL_LINES attribute.
        '''''
        '''''</param>
        '''''<returns>
        '''''
        '''''status
        '''''ViStatus
        '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. Examine the status code from each call to an NI-RFSA function to determine if an error has occurred.
        '''''
        '''''To obtain a text description of the status code and additional information about the error condition, call the niRFSA_GetError function. To clear the error information from NI-RFSA, call the niRFSA_ClearError function.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value
        '''''Meaning
        '''''0
        '''''Success
        '''''Positive Values
        '''''Warnings
        '''''Negative Values
        '''''Errors
        '''''
        '''''</returns>
        Public Function GetNumberOfSpectralLines(ByVal Channel_List As String, ByRef Number_of_Spectral_Lines As Integer) As Integer
            Dim pInvokeResult As Integer = PInvoke.GetNumberOfSpectralLines(Me._handle, Channel_List, Number_of_Spectral_Lines)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''
        '''''Checks the status of the acquisition. Use this function to check for any errors that may occur during signal acquisition or to check whether the device has completed the acquisition operation. 
        '''''
        '''''Supported Devices: NI 5661/5663
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''
        '''''vi
        '''''ViSession
        '''''Identifies your instrument session. vi is obtained from the niRFSA_init or niRFSA_initWithOptions function and identifies a
        '''''            particular instrument session.  
        '''''
        '''''</param>
        '''''<param name="Is_Done">
        '''''
        '''''isDone
        '''''ViBoolean*
        '''''Returns signal acquisition status.
        '''''
        '''''VI_TRUESignal acquisition is complete.
        '''''VI_FALSESignal acquisition is not complete.
        '''''
        '''''</param>
        '''''<returns>
        '''''
        '''''status
        '''''ViStatus
        '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. Examine the status code from each call to an NI-RFSA function to determine if an error has occurred.
        '''''
        '''''To obtain a text description of the status code and additional information about the error condition, call the niRFSA_GetError function. To clear the error information from NI-RFSA, call the niRFSA_ClearError function.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value
        '''''Meaning
        '''''0
        '''''Success
        '''''Positive Values
        '''''Warnings
        '''''Negative Values
        '''''Errors
        '''''
        '''''</returns>
        Public Function CheckAcquisitionStatus(ByRef Is_Done As Boolean) As Integer
            Dim Is_DoneAsUShort As UShort
            Dim pInvokeResult As Integer = PInvoke.CheckAcquisitionStatus(Me._handle, Is_DoneAsUShort)
            Is_Done = System.Convert.ToBoolean(Is_DoneAsUShort)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''
        '''''Resets the device to a default initialization state.
        '''''
        '''''Supported Devices: NI 5600/5601 (downconverter only mode), NI 5661/5663
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''
        '''''vi
        '''''ViSession
        '''''Identifies your instrument session. vi is obtained from the niRFSA_init or niRFSA_initWithOptions function and identifies a
        '''''            particular instrument session.  
        '''''
        '''''</param>
        '''''<returns>
        '''''
        '''''status
        '''''ViStatus
        '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. Examine the status code from each call to an NI-RFSA function to determine if an error has occurred.
        '''''
        '''''To obtain a text description of the status code and additional information about the error condition, call the niRFSA_GetError function. To clear the error information from NI-RFSA, call the niRFSA_ClearError function.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value
        '''''Meaning
        '''''0
        '''''Success
        '''''Positive Values
        '''''Warnings
        '''''Negative Values
        '''''Errors
        '''''
        '''''</returns>
        Public Function reset() As Integer
            Dim pInvokeResult As Integer = PInvoke.reset(Me._handle)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''
        '''''Commits settings to hardware. Calling this function is optional. Settings are automatically committed to hardware when you call the niRFSA_Initiate function, a read IQ function, or the niRFSA_ReadPowerSpectrumF64 function. 
        '''''
        '''''For improved accuracy, add a wait after calling this function and before calling the niRFSA_Initiate function to allow the device additional settling time. Refer to the specifications document that shipped with your device for information about settling time and accuracy.
        '''''
        '''''Supported Devices: NI 5600/5601 (downconverter only mode), NI 5661/5663
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''
        '''''vi
        '''''ViSession
        '''''Identifies your instrument session. vi is obtained from the niRFSA_init or niRFSA_initWithOptions function and identifies a
        '''''            particular instrument session.  
        '''''
        '''''</param>
        '''''<returns>
        '''''
        '''''status
        '''''ViStatus
        '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. Examine the status code from each call to an NI-RFSA function to determine if an error has occurred.
        '''''
        '''''To obtain a text description of the status code and additional information about the error condition, call the niRFSA_GetError function. To clear the error information from NI-RFSA, call the niRFSA_ClearError function.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value
        '''''Meaning
        '''''0
        '''''Success
        '''''Positive Values
        '''''Warnings
        '''''Negative Values
        '''''Errors
        '''''
        '''''</returns>
        Public Function Commit() As Integer
            Dim pInvokeResult As Integer = PInvoke.Commit(Me._handle)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''
        '''''Performs a self-test on the NI-RFSA device and returns the test result. This function performs a simple series of tests verifying that the NI-RFSA device is powered on and responding.
        '''''
        '''''Supported Devices: NI 5600/5601 (downconverter only mode), NI 5661/5663
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''
        '''''vi
        '''''ViSession
        '''''Identifies your instrument session. vi is obtained from the niRFSA_init or niRFSA_initWithOptions function and identifies a
        '''''            particular instrument session.  
        '''''
        '''''</param>
        '''''<param name="testResult">
        '''''
        '''''testResult
        '''''ViInt16*
        '''''Returns the value from the device self-test. A value of 0 means success.
        '''''
        '''''</param>
        '''''<param name="testMessage">
        '''''
        '''''testMessage[]
        '''''ViChar
        '''''Returns the self-test response string from the NI-RFSA device.
        '''''
        '''''</param>
        '''''<returns>
        '''''
        '''''status
        '''''ViStatus
        '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. Examine the status code from each call to an NI-RFSA function to determine if an error has occurred.
        '''''
        '''''To obtain a text description of the status code and additional information about the error condition, call the niRFSA_GetError function. To clear the error information from NI-RFSA, call the niRFSA_ClearError function.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value
        '''''Meaning
        '''''0
        '''''Success
        '''''Positive Values
        '''''Warnings
        '''''Negative Values
        '''''Errors
        '''''
        '''''</returns>
        Public Function self_test(ByRef testResult As Short, ByVal testMessage As System.Text.StringBuilder) As Integer
            Dim pInvokeResult As Integer = PInvoke.self_test(Me._handle, testResult, testMessage)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''
        '''''Self-calibrates the IF digitizer associated with the NI-RFSA device. If self calibration is performed successfully, the new calibration constants are immediately stored in the self calibration area of the digitizer EEPROM. Refer to the NI High-Speed Digitizers Help for more information about how often to self-calibrate. 
        '''''
        '''''Call this function to obtain more accurate acquisition results when the environmental conditions change significantly.
        '''''
        '''''Supported Devices: NI 5600/5601 (downconverter only mode), NI 5661/5663
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''
        '''''vi
        '''''ViSession
        '''''Identifies your instrument session. vi is obtained from the niRFSA_init or niRFSA_initWithOptions function and identifies a
        '''''            particular instrument session.  
        '''''
        '''''</param>
        '''''<returns>
        '''''
        '''''status
        '''''ViStatus
        '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. Examine the status code from each call to an NI-RFSA function to determine if an error has occurred.
        '''''
        '''''To obtain a text description of the status code and additional information about the error condition, call the niRFSA_GetError function. To clear the error information from NI-RFSA, call the niRFSA_ClearError function.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value
        '''''Meaning
        '''''0
        '''''Success
        '''''Positive Values
        '''''Warnings
        '''''Negative Values
        '''''Errors
        '''''
        '''''</returns>
        Public Function SelfCal() As Integer
            Dim pInvokeResult As Integer = PInvoke.SelfCal(Me._handle)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''
        '''''Corrects for temperature variations while acquiring the same signal for extended periods of time in a continuous acquisition. Measurements are affected by changes in temperature. NI-RFSA internally acquires the
        '''''            temperature every time you initiate an acquisition. If you are performing a continuous acquisition, National Instruments recommends calling this function once every 10&#160;minutes in a stable temperature environment to periodically update temperature calibration.
        '''''            Supported Devices: NI 5661/5663
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''
        '''''vi
        '''''ViSession
        '''''Identifies your instrument session. vi is obtained from the niRFSA_init or niRFSA_initWithOptions function and identifies a
        '''''            particular instrument session.  
        '''''
        '''''</param>
        '''''<returns>
        '''''
        '''''status
        '''''ViStatus
        '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. Examine the status code from each call to an NI-RFSA function to determine if an error has occurred.
        '''''
        '''''To obtain a text description of the status code and additional information about the error condition, call the niRFSA_GetError function. To clear the error information from NI-RFSA, call the niRFSA_ClearError function.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value
        '''''Meaning
        '''''0
        '''''Success
        '''''Positive Values
        '''''Warnings
        '''''Negative Values
        '''''Errors
        '''''
        '''''</returns>
        Public Function PerformThermalCorrection() As Integer
            Dim pInvokeResult As Integer = PInvoke.PerformThermalCorrection(Me._handle)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''
        '''''Returns the number of points acquired that have not been fetched yet.
        '''''
        '''''Supported Devices: NI 5661/5663
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''
        '''''vi
        '''''ViSession
        '''''Identifies your instrument session. vi is obtained from the niRFSA_init or niRFSA_initWithOptions function and identifies a
        '''''            particular instrument session.  
        '''''
        '''''</param>
        '''''<param name="Channel_List">
        '''''
        '''''channelList
        '''''ViConstString
        '''''Identifies which channels to apply settings. Use &quot;&quot; (an empty string) or VI_NULL to specify all channels.
        '''''
        '''''</param>
        '''''<param name="Record_Number">
        '''''
        '''''recordNumber
        '''''ViInt64
        '''''Specifies the record from which to read the backlog. Record numbers are zero-based. The default value is 0.
        '''''
        '''''</param>
        '''''<param name="Backlog">
        '''''
        '''''backlog
        '''''ViInt64*
        '''''Returns the number of samples available to read for the requested record.
        '''''
        '''''</param>
        '''''<returns>
        '''''
        '''''status
        '''''ViStatus
        '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. Examine the status code from each call to an NI-RFSA function to determine if an error has occurred.
        '''''
        '''''To obtain a text description of the status code and additional information about the error condition, call the niRFSA_GetError function. To clear the error information from NI-RFSA, call the niRFSA_ClearError function.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value
        '''''Meaning
        '''''0
        '''''Success
        '''''Positive Values
        '''''Warnings
        '''''Negative Values
        '''''Errors
        '''''
        '''''</returns>
        Public Function GetFetchBacklog(ByVal Channel_List As String, ByVal Record_Number As System.Int64, ByRef Backlog As System.Int64) As Integer
            Dim pInvokeResult As Integer = PInvoke.GetFetchBacklog(Me._handle, Channel_List, Record_Number, Backlog)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''
        '''''Returns the revision numbers of the NI-RFSA instrument driver.
        '''''Supported Devices: NI 5600/5601 (downconverter only mode), NI 5661/5663
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''
        '''''vi
        '''''ViSession
        '''''Identifies your instrument session. vi is obtained from the niRFSA_init or niRFSA_initWithOptions function and identifies a
        '''''            particular instrument session.  
        '''''
        '''''</param>
        '''''<param name="Instrument_Driver_Revision">
        '''''
        '''''driverRev
        '''''ViChar[]
        '''''Returns the instrument driver software revision numbers in the form of a string. The value of the NIRFSA_ATTR_SPECIFIC_DRIVER_REVISION attribute is returned.
        '''''
        '''''You must pass a ViChar array with at least 256&#160;bytes.
        '''''
        '''''</param>
        '''''<param name="Firmware_Revision">
        '''''
        '''''instRev
        '''''ViChar[]
        '''''Returns the instrument firmware revision numbers in the form of a string. The value of the NIRFSA_ATTR_INSTRUMENT_FIRMWARE_REVISION attribute is returned.
        '''''
        '''''You must pass a ViChar array with at least 256&#160;bytes.
        '''''
        '''''</param>
        '''''<returns>
        '''''
        '''''status
        '''''ViStatus
        '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. Examine the status code from each call to an NI-RFSA function to determine if an error has occurred.
        '''''
        '''''To obtain a text description of the status code and additional information about the error condition, call the niRFSA_GetError function. To clear the error information from NI-RFSA, call the niRFSA_ClearError function.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value
        '''''Meaning
        '''''0
        '''''Success
        '''''Positive Values
        '''''Warnings
        '''''Negative Values
        '''''Errors
        '''''
        '''''</returns>
        Public Function revision_query(ByVal Instrument_Driver_Revision As System.Text.StringBuilder, ByVal Firmware_Revision As System.Text.StringBuilder) As Integer
            Dim pInvokeResult As Integer = PInvoke.revision_query(Me._handle, Instrument_Driver_Revision, Firmware_Revision)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''
        '''''Returns information about the power spectrum NI-RFSA computes.
        '''''
        '''''Note:The NI Spectral Measurements Toolkit (SMT) requires this information. 
        '''''Supported Devices: NI 5661/5663
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''
        '''''vi
        '''''ViSession
        '''''Identifies your instrument session. vi is obtained from the niRFSA_init or niRFSA_initWithOptions function and identifies a
        '''''            particular instrument session.  
        '''''
        '''''</param>
        '''''<param name="Spectrum_Info">
        '''''
        '''''spectrumInfo
        '''''SmtSpectrumInfo*
        '''''Returns a cluster containing information about the power spectrum NI-RFSA computes that is needed by the SMT.
        '''''
        '''''</param>
        '''''<returns>
        '''''
        '''''status
        '''''ViStatus
        '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. Examine the status code from each call to an NI-RFSA function to determine if an error has occurred.
        '''''
        '''''To obtain a text description of the status code and additional information about the error condition, call the niRFSA_GetError function. To clear the error information from NI-RFSA, call the niRFSA_ClearError function.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value
        '''''Meaning
        '''''0
        '''''Success
        '''''Positive Values
        '''''Warnings
        '''''Negative Values
        '''''Errors
        '''''
        '''''</returns>
        Public Function GetSpectralInfoForSMT(ByRef Spectrum_Info As smtSpectrumInfo) As Integer
            Dim pInvokeResult As Integer = PInvoke.GetSpectralInfoForSMT(Me._handle, Spectrum_Info)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''
        '''''Returns the IF response, based upon current NI-RFSA settings. The NI 5661/5663 automatically corrects for the IF response when Digital IF Equalization is enabled, which is the default state. If you are using downconverter only mode, you can use information returned from this VI to correct your measurement.
        '''''Supported Devices: NI 5600/5601 (downconverter only mode), NI 5661/5663
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''
        '''''vi
        '''''ViSession
        '''''Identifies your instrument session. vi is obtained from the niRFSA_init or niRFSA_initWithOptions function and identifies a
        '''''            particular instrument session.  
        '''''
        '''''</param>
        '''''<param name="Channel_List">
        '''''
        '''''channelList
        '''''ViConstString
        '''''Identifies which channels to apply settings. Use &quot;&quot; (an empty string) or VI_NULL to specify all channels.
        '''''
        '''''</param>
        '''''<param name="Buffer_Size">
        '''''
        '''''bufferSize
        '''''ViInt32
        '''''Specifies the size of the array you specify for the powerSpectrumData parameter. Use the niRFSA_GetNumberOfSpectralLines function to learn the array size you need to allocate. The array must be at least as large as the number of spectral lines that NI-RFSA computes for the power spectrum.
        '''''
        '''''</param>
        '''''<param name="Frequencies">
        '''''
        '''''frequencies[]
        '''''ViReal64
        '''''Returns an array containing the frequencies, in hertz (Hz), that correspond to the response data.
        '''''
        '''''Pass VI_NULL if you do not want to use this parameter.
        '''''
        '''''</param>
        '''''<param name="Magnitude_Response">
        '''''
        '''''magnitudeResponse[]
        '''''ViReal64
        '''''Returns an array containing the magnitude IF response, in decibels (dB). The magnitude IF response is normalized to the center frequency at each frequency in the frequencies array.
        '''''
        '''''Pass VI_NULL if you do not want to use this parameter.
        '''''
        '''''</param>
        '''''<param name="Phase_Response">
        '''''
        '''''phaseResponse[]
        '''''ViReal64
        '''''Returns an array containing the phase IF response, in degrees. The phase IF response is normalized to the center frequency at each frequency entry in the frequencies array.
        '''''
        '''''Pass VI_NULL if you do not want to use this parameter.
        '''''
        '''''</param>
        '''''<param name="Number_of_Frequencies">
        '''''
        '''''numberOfFrequencies
        '''''ViInt32*
        '''''Returns the required number of elements in the frequencies array and the response arrays. If bufferSize is 0, this parameter returns the expected array size. The expected array size depends on which NI-RFSA device you use (NI&#160;5661 or NI&#160;5663) and on the current settings (NI&#160;5663 only).
        '''''
        '''''</param>
        '''''<returns>
        '''''
        '''''status
        '''''ViStatus
        '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. Examine the status code from each call to an NI-RFSA function to determine if an error has occurred.
        '''''
        '''''To obtain a text description of the status code and additional information about the error condition, call the niRFSA_GetError function. To clear the error information from NI-RFSA, call the niRFSA_ClearError function.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value
        '''''Meaning
        '''''0
        '''''Success
        '''''Positive Values
        '''''Warnings
        '''''Negative Values
        '''''Errors
        '''''
        '''''</returns>
        Public Function GetFrequencyResponse(ByVal Channel_List As String, ByVal Buffer_Size As Integer, ByVal Frequencies() As Double, ByVal Magnitude_Response() As Double, ByVal Phase_Response() As Double, ByRef Number_of_Frequencies As Integer) As Integer
            Dim pInvokeResult As Integer = PInvoke.GetFrequencyResponse(Me._handle, Channel_List, Buffer_Size, Frequencies, Magnitude_Response, Phase_Response, Number_of_Frequencies)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        Public Overloads Sub Dispose() Implements System.IDisposable.Dispose
            Me.Dispose(True)
            System.GC.SuppressFinalize(Me)
        End Sub

        Private Overloads Sub Dispose(ByVal disposing As Boolean)
            If (Me._disposed = False) Then
                PInvoke.close(Me._handle)
                Me._handle = System.IntPtr.Zero
            End If
            Me._disposed = True
        End Sub

        Protected Overrides Sub Finalize()
            Me.Dispose(False)
        End Sub

        Public Overloads Sub SetInt32(ByVal propertyId As niRFSAProperties, ByVal repeatedCapabilityOrChannel As String, ByVal val As Integer)
            PInvoke.TestForError(Me._handle, PInvoke.SetAttributeViInt32(Me._handle, repeatedCapabilityOrChannel, CType(propertyId, Integer), val))
        End Sub

        Public Overloads Sub SetInt32(ByVal propertyId As niRFSAProperties, ByVal val As Integer)
            Me.SetInt32(propertyId, "", val)
        End Sub

        Public Overloads Function GetInt32(ByVal propertyId As niRFSAProperties, ByVal repeatedCapabilityOrChannel As String) As Integer
            Dim val As Integer
            PInvoke.TestForError(Me._handle, PInvoke.GetAttributeViInt32(Me._handle, repeatedCapabilityOrChannel, CType(propertyId, Integer), val))
            Return val
        End Function

        Public Overloads Function GetInt32(ByVal propertyId As niRFSAProperties) As Integer
            Return Me.GetInt32(propertyId, "")
        End Function

        Public Overloads Sub SetDouble(ByVal propertyId As niRFSAProperties, ByVal repeatedCapabilityOrChannel As String, ByVal val As Double)
            PInvoke.TestForError(Me._handle, PInvoke.SetAttributeViReal64(Me._handle, repeatedCapabilityOrChannel, CType(propertyId, Integer), val))
        End Sub

        Public Overloads Sub SetDouble(ByVal propertyId As niRFSAProperties, ByVal val As Double)
            Me.SetDouble(propertyId, "", val)
        End Sub

        Public Overloads Function GetDouble(ByVal propertyId As niRFSAProperties, ByVal repeatedCapabilityOrChannel As String) As Double
            Dim val As Double
            PInvoke.TestForError(Me._handle, PInvoke.GetAttributeViReal64(Me._handle, repeatedCapabilityOrChannel, CType(propertyId, Integer), val))
            Return val
        End Function

        Public Overloads Function GetDouble(ByVal propertyId As niRFSAProperties) As Double
            Return Me.GetDouble(propertyId, "")
        End Function

        Public Overloads Sub SetBoolean(ByVal propertyId As niRFSAProperties, ByVal repeatedCapabilityOrChannel As String, ByVal val As Boolean)
            PInvoke.TestForError(Me._handle, PInvoke.SetAttributeViBoolean(Me._handle, repeatedCapabilityOrChannel, CType(propertyId, Integer), System.Convert.ToUInt16(val)))
        End Sub

        Public Overloads Sub SetBoolean(ByVal propertyId As niRFSAProperties, ByVal val As Boolean)
            Me.SetBoolean(propertyId, "", val)
        End Sub

        Public Overloads Function GetBoolean(ByVal propertyId As niRFSAProperties, ByVal repeatedCapabilityOrChannel As String) As Boolean
            Dim val As UShort
            PInvoke.TestForError(Me._handle, PInvoke.GetAttributeViBoolean(Me._handle, repeatedCapabilityOrChannel, CType(propertyId, Integer), val))
            Return System.Convert.ToBoolean(val)
        End Function

        Public Overloads Function GetBoolean(ByVal propertyId As niRFSAProperties) As Boolean
            Return Me.GetBoolean(propertyId, "")
        End Function

        Public Overloads Sub SetString(ByVal propertyId As niRFSAProperties, ByVal repeatedCapabilityOrChannel As String, ByVal val As String)
            PInvoke.TestForError(Me._handle, PInvoke.SetAttributeViString(Me._handle, repeatedCapabilityOrChannel, CType(propertyId, Integer), val))
        End Sub

        Public Overloads Sub SetString(ByVal propertyId As niRFSAProperties, ByVal val As String)
            Me.SetString(propertyId, "", val)
        End Sub

        Public Overloads Function GetString(ByVal propertyId As niRFSAProperties, ByVal repeatedCapabilityOrChannel As String) As String
            Dim newVal As System.Text.StringBuilder = New System.Text.StringBuilder(512)
            Dim size As Integer = PInvoke.GetAttributeViString(Me._handle, repeatedCapabilityOrChannel, CType(propertyId, Integer), 512, newVal)
            If (size < 0) Then
                PInvoke.ThrowError(Me._handle, size)
            Else
                If (size > 0) Then
                    newVal.Capacity = size
                    PInvoke.TestForError(Me._handle, PInvoke.GetAttributeViString(Me._handle, repeatedCapabilityOrChannel, CType(propertyId, Integer), size, newVal))
                End If
            End If
            Return newVal.ToString
        End Function

        Public Overloads Function GetString(ByVal propertyId As niRFSAProperties) As String
            Return Me.GetString(propertyId, "")
        End Function

        Public Function GetInt64(ByVal Channel_Name As String, ByVal Attribute_ID As Integer, <Out()> ByRef Attribute_Value As System.Int64) As Integer
            Dim pInvokeResult As Integer = PInvoke.GetAttributeViInt64(Me._handle, Channel_Name, Attribute_ID, Attribute_Value)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        Public Function GetSession(ByVal Channel_Name As String, ByVal Attribute_ID As Integer, <Out()> ByRef Attribute_Value As System.IntPtr) As Integer
            Dim pInvokeResult As Integer = PInvoke.GetAttributeViSession(Me._handle, Channel_Name, Attribute_ID, Attribute_Value)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        Public Function SetInt64(ByVal Channel_Name As String, ByVal Attribute_ID As Integer, <Out()> ByRef Attribute_Value As System.Int64) As Integer
            Dim pInvokeResult As Integer = PInvoke.GetAttributeViInt64(Me._handle, Channel_Name, Attribute_ID, Attribute_Value)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        Public Function SetSession(ByVal Channel_Name As String, ByVal Attribute_ID As Integer, ByVal Attribute_Value As System.IntPtr) As Integer
            Dim pInvokeResult As Integer = PInvoke.SetAttributeViSession(Me._handle, Channel_Name, Attribute_ID, Attribute_Value)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function
        Private Class PInvoke

            <DllImport(rfsaModule, EntryPoint:="niRFSA_init", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function init(ByVal Resource_Name As String, ByVal ID_Query As UShort, ByVal Reset As UShort, <Out()> ByRef Instrument_Handle As System.IntPtr) As Integer
            End Function

            <DllImport(rfsaModule, EntryPoint:="niRFSA_InitWithOptions", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function InitWithOptions(ByVal Resource_Name As String, ByVal ID_Query As UShort, ByVal Reset As UShort, ByVal Option_String As String, <Out()> ByRef Instrument_Handle As System.IntPtr) As Integer
            End Function

            <DllImport(rfsaModule, EntryPoint:="niRFSA_ConfigureAcquisitionType", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ConfigureAcquisitionType(ByVal Instrument_Handle As System.IntPtr, ByVal Acquisition_Type As Integer) As Integer
            End Function

            <DllImport(rfsaModule, EntryPoint:="niRFSA_ConfigureReferenceLevel", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ConfigureReferenceLevel(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_List As String, ByVal Reference_Level As Double) As Integer
            End Function

            <DllImport(rfsaModule, EntryPoint:="niRFSA_ConfigureIQCarrierFrequency", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ConfigureIQCarrierFrequency(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_List As String, ByVal Carrier_Frequency As Double) As Integer
            End Function

            <DllImport(rfsaModule, EntryPoint:="niRFSA_ConfigureIQRate", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ConfigureIQRate(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_List As String, ByVal IQ_Rate As Double) As Integer
            End Function

            <DllImport(rfsaModule, EntryPoint:="niRFSA_ConfigureNumberOfSamples", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ConfigureNumberOfSamples(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_List As String, ByVal Number_of_Samples_Is_Finite As UShort, ByVal Samples_Per_Record As System.Int64) As Integer
            End Function

            <DllImport(rfsaModule, EntryPoint:="niRFSA_ConfigureNumberOfRecords", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ConfigureNumberOfRecords(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_List As String, ByVal Number_of_Records_Is_Finite As UShort, ByVal Number_of_Records As System.Int64) As Integer
            End Function

            <DllImport(rfsaModule, EntryPoint:="niRFSA_ConfigureSpectrumFrequencyCenterSpan", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ConfigureSpectrumFrequencyCenterSpan(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_List As String, ByVal Center_Frequency As Double, ByVal Span As Double) As Integer
            End Function

            <DllImport(rfsaModule, EntryPoint:="niRFSA_ConfigureSpectrumFrequencyStartStop", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ConfigureSpectrumFrequencyStartStop(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_List As String, ByVal Start_Frequency As Double, ByVal Stop_Frequency As Double) As Integer
            End Function

            <DllImport(rfsaModule, EntryPoint:="niRFSA_ConfigureResolutionBandwidth", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ConfigureResolutionBandwidth(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_List As String, ByVal Resolution_Bandwidth As Double) As Integer
            End Function

            <DllImport(rfsaModule, EntryPoint:="niRFSA_ConfigureDigitalEdgeStartTrigger", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ConfigureDigitalEdgeStartTrigger(ByVal Instrument_Handle As System.IntPtr, ByVal Source As String, ByVal Edge As Integer) As Integer
            End Function

            <DllImport(rfsaModule, EntryPoint:="niRFSA_ConfigureSoftwareEdgeStartTrigger", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ConfigureSoftwareEdgeStartTrigger(ByVal Instrument_Handle As System.IntPtr) As Integer
            End Function

            <DllImport(rfsaModule, EntryPoint:="niRFSA_DisableStartTrigger", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function DisableStartTrigger(ByVal Instrument_Handle As System.IntPtr) As Integer
            End Function

            <DllImport(rfsaModule, EntryPoint:="niRFSA_ConfigureDigitalEdgeRefTrigger", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ConfigureDigitalEdgeRefTrigger(ByVal Instrument_Handle As System.IntPtr, ByVal Source As String, ByVal Edge As Integer, ByVal Pretrigger_Samples As System.Int64) As Integer
            End Function

            <DllImport(rfsaModule, EntryPoint:="niRFSA_ConfigureIQPowerEdgeRefTrigger", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ConfigureIQPowerEdgeRefTrigger(ByVal Instrument_Handle As System.IntPtr, ByVal Source As String, ByVal Level As Double, ByVal Slope As Integer, ByVal Pretrigger_Samples As System.Int64) As Integer
            End Function

            <DllImport(rfsaModule, EntryPoint:="niRFSA_ConfigureSoftwareEdgeRefTrigger", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ConfigureSoftwareEdgeRefTrigger(ByVal Instrument_Handle As System.IntPtr, ByVal Pretrigger_Samples As System.Int64) As Integer
            End Function

            <DllImport(rfsaModule, EntryPoint:="niRFSA_DisableRefTrigger", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function DisableRefTrigger(ByVal Instrument_Handle As System.IntPtr) As Integer
            End Function

            <DllImport(rfsaModule, EntryPoint:="niRFSA_ConfigureDigitalEdgeAdvanceTrigger", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ConfigureDigitalEdgeAdvanceTrigger(ByVal Instrument_Handle As System.IntPtr, ByVal Source As String, ByVal Edge As Integer) As Integer
            End Function

            <DllImport(rfsaModule, EntryPoint:="niRFSA_ConfigureSoftwareEdgeAdvanceTrigger", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ConfigureSoftwareEdgeAdvanceTrigger(ByVal Instrument_Handle As System.IntPtr) As Integer
            End Function

            <DllImport(rfsaModule, EntryPoint:="niRFSA_DisableAdvanceTrigger", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function DisableAdvanceTrigger(ByVal Instrument_Handle As System.IntPtr) As Integer
            End Function

            <DllImport(rfsaModule, EntryPoint:="niRFSA_SendSoftwareEdgeTrigger", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function SendSoftwareEdgeTrigger(ByVal Instrument_Handle As System.IntPtr, ByVal Trigger As Integer, ByVal Trigger_Identifier As String) As Integer
            End Function

            <DllImport(rfsaModule, EntryPoint:="niRFSA_ExportSignal", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ExportSignal(ByVal Instrument_Handle As System.IntPtr, ByVal Signal As Integer, ByVal Signal_Identifier As String, ByVal Output_Terminal As String) As Integer
            End Function

            <DllImport(rfsaModule, EntryPoint:="niRFSA_ConfigureRefClock", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ConfigureRefClock(ByVal Instrument_Handle As System.IntPtr, ByVal Ref_Clock_Source As String, ByVal Ref_Clock_Rate As Double) As Integer
            End Function

            <DllImport(rfsaModule, EntryPoint:="niRFSA_ConfigurePXIChassisClk10", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ConfigurePXIChassisClk10(ByVal Instrument_Handle As System.IntPtr, ByVal PXI_Clk_10_Source As String) As Integer
            End Function

            <DllImport(rfsaModule, EntryPoint:="niRFSA_ResetAttribute", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ResetAttribute(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Attribute_ID As Integer) As Integer
            End Function

            <DllImport(rfsaModule, EntryPoint:="niRFSA_Initiate", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function Initiate(ByVal Instrument_Handle As System.IntPtr) As Integer
            End Function

            <DllImport(rfsaModule, EntryPoint:="niRFSA_FetchIQSingleRecordComplexI16", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function FetchIQSingleRecordComplexI16(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_List As String, ByVal Record_Number As System.Int64, ByVal Number_of_Samples As System.Int64, ByVal Timeout As Double, <Out()> ByVal Data As Short(), <Out()> ByRef Waveform_Info As niRFSA_wfmInfo) As Integer
            End Function

            <DllImport(rfsaModule, EntryPoint:="niRFSA_FetchIQSingleRecordComplexF64", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function FetchIQSingleRecordComplexF64(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_List As String, ByVal Record_Number As System.Int64, ByVal Number_of_Samples As System.Int64, ByVal Timeout As Double, <Out()> ByVal Data As niComplexNumber(), <Out()> ByRef Waveform_Info As niRFSA_wfmInfo) As Integer
            End Function

            <DllImport(rfsaModule, EntryPoint:="niRFSA_ReadIQSingleRecordComplexF64", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ReadIQSingleRecordComplexF64(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_List As String, ByVal Timeout As Double, <Out()> ByVal Data As niComplexNumber(), ByVal Data_Array_Size As System.Int64, <Out()> ByRef Waveform_Info As niRFSA_wfmInfo) As Integer
            End Function

            <DllImport(rfsaModule, EntryPoint:="niRFSA_FetchIQMultiRecordComplexI16", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function FetchIQMultiRecordComplexI16(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_List As String, ByVal Starting_Record As System.Int64, ByVal Number_of_Records As System.Int64, ByVal Number_of_Samples As System.Int64, ByVal Timeout As Double, <Out()> ByVal Data() As Short, <Out()> ByRef Waveform_Info As niRFSA_wfmInfo) As Integer
            End Function

            <DllImport(rfsaModule, EntryPoint:="niRFSA_FetchIQMultiRecordComplexF64", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function FetchIQMultiRecordComplexF64(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_List As String, ByVal Starting_Record As System.Int64, ByVal Number_of_Records As System.Int64, ByVal Number_of_Samples As System.Int64, ByVal Timeout As Double, <Out()> ByVal Data As niComplexNumber(), <Out()> ByRef Waveform_Info As niRFSA_wfmInfo) As Integer
            End Function

            <DllImport(rfsaModule, EntryPoint:="niRFSA_Abort", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function Abort(ByVal Instrument_Handle As System.IntPtr) As Integer
            End Function

            <DllImport(rfsaModule, EntryPoint:="niRFSA_ReadPowerSpectrumF64", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ReadPowerSpectrumF64(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_List As String, ByVal Timeout As Double, <[In](), Out()> ByVal Power_Spectrum_Data As Double(), ByVal Data_Array_Size As Integer, <Out()> ByRef Spectrum_Info As niRFSA_spectrumInfo) As Integer
            End Function

            <DllImport(rfsaModule, EntryPoint:="niRFSA_GetNumberOfSpectralLines", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function GetNumberOfSpectralLines(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_List As String, <Out()> ByRef Number_of_Spectral_Lines As Integer) As Integer
            End Function

            <DllImport(rfsaModule, EntryPoint:="niRFSA_CheckAcquisitionStatus", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function CheckAcquisitionStatus(ByVal Instrument_Handle As System.IntPtr, <Out()> ByRef Is_Done As UShort) As Integer
            End Function

            <DllImport(rfsaModule, EntryPoint:="niRFSA_reset", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function reset(ByVal Instrument_Handle As System.IntPtr) As Integer
            End Function

            <DllImport(rfsaModule, EntryPoint:="niRFSA_Commit", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function Commit(ByVal Instrument_Handle As System.IntPtr) As Integer
            End Function

            <DllImport(rfsaModule, EntryPoint:="niRFSA_self_test", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function self_test(ByVal Instrument_Handle As System.IntPtr, <Out()> ByRef testResult As Short, ByVal testMessage As System.Text.StringBuilder) As Integer
            End Function

            <DllImport(rfsaModule, EntryPoint:="niRFSA_SelfCal", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function SelfCal(ByVal Instrument_Handle As System.IntPtr) As Integer
            End Function

            <DllImport(rfsaModule, EntryPoint:="niRFSA_PerformThermalCorrection", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function PerformThermalCorrection(ByVal Instrument_Handle As System.IntPtr) As Integer
            End Function

            <DllImport(rfsaModule, EntryPoint:="niRFSA_GetFetchBacklog", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function GetFetchBacklog(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_List As String, ByVal Record_Number As System.Int64, <Out()> ByRef Backlog As System.Int64) As Integer
            End Function

            <DllImport(rfsaModule, EntryPoint:="niRFSA_revision_query", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function revision_query(ByVal Instrument_Handle As System.IntPtr, ByVal Instrument_Driver_Revision As System.Text.StringBuilder, ByVal Firmware_Revision As System.Text.StringBuilder) As Integer
            End Function

            <DllImport(rfsaModule, EntryPoint:="niRFSA_GetSpectralInfoForSMT", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function GetSpectralInfoForSMT(ByVal Instrument_Handle As System.IntPtr, <Out()> ByRef Spectrum_Info As smtSpectrumInfo) As Integer
            End Function

            <DllImport(rfsaModule, EntryPoint:="niRFSA_GetFrequencyResponse", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function GetFrequencyResponse(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_List As String, ByVal Buffer_Size As Integer, <[In](), Out()> ByVal Frequencies As Double(), <[In](), Out()> ByVal Magnitude_Response As Double(), <[In](), Out()> ByVal Phase_Response As Double(), <Out()> ByRef Number_of_Frequencies As Integer) As Integer
            End Function

            <DllImport(rfsaModule, EntryPoint:="niRFSA_close", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function close(ByVal Instrument_Handle As System.IntPtr) As Integer
            End Function

            <DllImport(rfsaModule, EntryPoint:="niRFSA_error_message", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function error_message(ByVal Instrument_Handle As System.IntPtr, ByVal Error_Code As Integer, ByVal Error_Message_2 As System.Text.StringBuilder) As Integer
            End Function

            <DllImport(rfsaModule, EntryPoint:="niRFSA_GetAttributeViInt32", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function GetAttributeViInt32(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Attribute_ID As Integer, <Out()> ByRef Attribute_Value As Integer) As Integer
            End Function

            <DllImport(rfsaModule, EntryPoint:="niRFSA_GetAttributeViInt64", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function GetAttributeViInt64(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Attribute_ID As Integer, <Out()> ByRef Attribute_Value As System.Int64) As Integer
            End Function

            <DllImport(rfsaModule, EntryPoint:="niRFSA_GetAttributeViReal64", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function GetAttributeViReal64(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Attribute_ID As Integer, <Out()> ByRef Attribute_Value As Double) As Integer
            End Function

            <DllImport(rfsaModule, EntryPoint:="niRFSA_GetAttributeViString", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function GetAttributeViString(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Attribute_ID As Integer, ByVal Buffer_Size As Integer, ByVal Attribute_Value As System.Text.StringBuilder) As Integer
            End Function

            <DllImport(rfsaModule, EntryPoint:="niRFSA_GetAttributeViBoolean", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function GetAttributeViBoolean(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Attribute_ID As Integer, <Out()> ByRef Attribute_Value As UShort) As Integer
            End Function

            <DllImport(rfsaModule, EntryPoint:="niRFSA_GetAttributeViSession", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function GetAttributeViSession(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Attribute_ID As Integer, <Out()> ByRef Attribute_Value As System.IntPtr) As Integer
            End Function

            <DllImport(rfsaModule, EntryPoint:="niRFSA_SetAttributeViInt32", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function SetAttributeViInt32(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Attribute_ID As Integer, ByVal Attribute_Value As Integer) As Integer
            End Function

            <DllImport(rfsaModule, EntryPoint:="niRFSA_SetAttributeViInt64", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function SetAttributeViInt64(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Attribute_ID As Integer, ByVal Attribute_Value As Integer) As Integer
            End Function

            <DllImport(rfsaModule, EntryPoint:="niRFSA_SetAttributeViReal64", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function SetAttributeViReal64(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Attribute_ID As Integer, ByVal Attribute_Value As Double) As Integer
            End Function

            <DllImport(rfsaModule, EntryPoint:="niRFSA_SetAttributeViString", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function SetAttributeViString(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Attribute_ID As Integer, ByVal Attribute_Value As String) As Integer
            End Function

            <DllImport(rfsaModule, EntryPoint:="niRFSA_SetAttributeViBoolean", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function SetAttributeViBoolean(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Attribute_ID As Integer, ByVal Attribute_Value As UShort) As Integer
            End Function

            <DllImport(rfsaModule, EntryPoint:="niRFSA_SetAttributeViSession", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function SetAttributeViSession(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Attribute_ID As Integer, ByVal Attribute_Value As System.IntPtr) As Integer
            End Function

            <DllImport(rfsaModule, EntryPoint:="niRFSA_GetError", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function GetError(ByVal Instrument_Handle As System.IntPtr, <Out()> ByRef errorCode As Integer, ByVal BufferSize As Integer, ByVal Description As System.Text.StringBuilder) As Integer
            End Function


            Public Shared Function TestForError(ByVal handle As System.IntPtr, ByVal status As Integer) As Integer
                If (status < 0) Then
                    PInvoke.ThrowError(handle, status)
                End If
                Return status
            End Function

            Public Shared Function ThrowError(ByVal handle As System.IntPtr, ByVal code As Integer) As Integer
                Dim status As Integer
                Dim size As Integer = PInvoke.GetError(handle, status, 0, Nothing)
                Dim msg As System.Text.StringBuilder = New System.Text.StringBuilder
                If (size >= 0) Then
                    msg.Capacity = size
                    PInvoke.GetError(handle, status, size, msg)
                End If
                Throw New System.Runtime.InteropServices.ExternalException(msg.ToString, code)
            End Function
        End Class
    End Class

    Public Class niRFSAConstants

        Public Const Iq As Integer = 100

        Public Const Spectrum As Integer = 101

        Public Const Pfi0Str As String = "PFI0"

        Public Const Pfi1Str As String = "PFI1"

        Public Const Rtsi0Str As String = "PXI_Trig0"

        Public Const Rtsi1Str As String = "PXI_Trig1"

        Public Const Rtsi2Str As String = "PXI_Trig2"

        Public Const Rtsi3Str As String = "PXI_Trig3"

        Public Const Rtsi4Str As String = "PXI_Trig4"

        Public Const Rtsi5Str As String = "PXI_Trig5"

        Public Const Rtsi6Str As String = "PXI_Trig6"

        Public Const Rtsi7Str As String = "PXI_Trig7"

        Public Const PxiStarStr As String = "PXI_STAR"

        Public Const RisingEdge As Integer = 900

        Public Const FallingEdge As Integer = 901

        Public Const RisingSlope As Integer = 1000

        Public Const FallingSlope As Integer = 1001

        Public Const StartTrigger As Integer = 1100

        Public Const RefTrigger As Integer = 702

        Public Const AdvanceTrigger As Integer = 1102

        Public Const ArmRefTrigger As Integer = 1103

        Public Const ReadyForStartEvent As Integer = 1200

        Public Const ReadyForAdvanceEvent As Integer = 1202

        Public Const ReadyForRefEvent As Integer = 1201

        Public Const EndOfRecordEvent As Integer = 1203

        Public Const DoneEvent As Integer = 1204

        Public Const RefClock As Integer = 1205

        Public Const DoNotExportStr As String = ""

        Public Const ClkOutStr As String = "ClkOut"

        Public Const RefOutStr As String = "RefOut"

        Public Const PxiTrig0Str As String = "PXI_Trig0"

        Public Const PxiTrig1Str As String = "PXI_Trig1"

        Public Const PxiTrig2Str As String = "PXI_Trig2"

        Public Const PxiTrig3Str As String = "PXI_Trig3"

        Public Const PxiTrig4Str As String = "PXI_Trig4"

        Public Const PxiTrig5Str As String = "PXI_Trig5"

        Public Const PxiTrig6Str As String = "PXI_Trig6"

        Public Const Dbm As Integer = 200

        Public Const VoltsSquared As Integer = 201

        Public Const Dbmv As Integer = 202

        Public Const Dbuv As Integer = 203

        Public Const Rbw3db As Integer = 300

        Public Const Rbw6db As Integer = 301

        Public Const RbwBinWidth As Integer = 302

        Public Const RbwEnbw As Integer = 303

        Public Const NoAveraging As Integer = 400

        Public Const RmsAveraging As Integer = 401

        Public Const VectorAveraging As Integer = 402

        Public Const PeakHoldAveraging As Integer = 403

        Public Const Uniform As Integer = 500

        Public Const Hanning As Integer = 501

        Public Const Hamming As Integer = 502

        Public Const BlackmanHarris As Integer = 503

        Public Const ExactBlackman As Integer = 504

        Public Const Blackman As Integer = 505

        Public Const FlatTop As Integer = 506

        Public Const _4TermBlackmanHarris As Integer = 507

        Public Const _7TermBlackmanHarris As Integer = 508

        Public Const LowSideLobe As Integer = 509

        Public Const MostRecentSample As Integer = 700

        Public Const FirstSample As Integer = 701

        Public Const FirstPretriggerSample As Integer = 703

        Public Const CurrentReadPosition As Integer = 704

        Public Const OnboardClockStr As String = "OnboardClock"

        Public Const RefInStr As String = "RefIn"

        Public Const PxiClkStr As String = "PXI_Clk"

        Public Const ClkInStr As String = "ClkIn"

        Public Const NoneStr As String = "None"

        Public Const None As Integer = 600

        Public Const DigitalEdge As Integer = 601

        Public Const SoftwareEdge As Integer = 604

        Public Const PxiTrig7Str As String = "PXI_Trig7"

        Public Const CalClkOutStr As String = "ClkOut"

        Public Const IqPowerEdge As Integer = 603

        Public Const Low As Integer = 800

        Public Const Medium As Integer = 801

        Public Const High As Integer = 802

        Public Const LoInjectionHighSide As Integer = 1300

        Public Const LoInjectionLowSide As Integer = 1301
    End Class

    <StructLayout(System.Runtime.InteropServices.LayoutKind.Sequential, Pack:=8)> _
    Public Structure niComplexNumber

        Public Real As Double

        Public Imaginary As Double

    End Structure


    <StructLayout(System.Runtime.InteropServices.LayoutKind.Sequential, Pack:=8)> _
    Public Structure niRFSA_wfmInfo

        Public absoluteInitialX As Double

        Public relativeInitialX As Double

        Public xIncrement As Double

        Public actualSamples As System.Int64

        Public offset As Double

        Public gain As Double

        Public reserved1 As Double

        Public reserved2 As Double

    End Structure

    <StructLayout(System.Runtime.InteropServices.LayoutKind.Sequential, Pack:=8)> _
    Public Structure niRFSA_spectrumInfo

        Public initialFrequency As Double

        Public frequencyIncrement As Double

        Public numberOfSpectralLines As System.Int32

        Public reserved1 As Double

        Public reserved2 As Double

        Public reserved3 As Double

        Public reserved4 As Double

        Public reserved5 As Double

    End Structure


    <StructLayout(System.Runtime.InteropServices.LayoutKind.Sequential, Pack:=8)> _
    Public Structure smtSpectrumInfo

        Public spectrumType As System.Int16

        Public linearDB As System.Int16

        Public window As System.Int16

        Public windowSize As System.Int32

        Public FFTSize As System.Int32

    End Structure

    Public Enum niRFSAProperties

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        AcquisitionType = 1150001

        '''''<summary>
        '''''System.Double
        '''''</summary>
        ReferenceLevel = 1150004

        '''''<summary>
        '''''System.Double
        '''''</summary>
        Attenuation = 1150005

        '''''<summary>
        '''''System.Double
        '''''</summary>
        MixerLevel = 1150006

        '''''<summary>
        '''''System.Double
        '''''</summary>
        IqCarrierFrequency = 1150059

        '''''<summary>
        '''''System.Double
        '''''</summary>
        IqRate = 1150007

        '''''<summary>
        '''''System.Double
        '''''</summary>
        SpectrumCenterFrequency = 1150002

        '''''<summary>
        '''''System.Double
        '''''</summary>
        SpectrumSpan = 1150003

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        PowerSpectrumUnits = 1150012

        '''''<summary>
        '''''System.Double
        '''''</summary>
        ResolutionBandwidth = 1150013

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        ResolutionBandwidthType = 1150014

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        NumberOfSpectralLines = 1150018

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        SpectrumAveragingMode = 1150016

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        SpectrumNumberOfAverages = 1150015

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        FftWindowType = 1150017

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        FftWindowSize = 1150049

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        FftSize = 1150050

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        FetchRelativeTo = 1150045

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        FetchOffset = 1150046

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        RecordsDone = 1150047

        '''''<summary>
        '''''System.String
        '''''</summary>
        RefClockSource = 1150019

        '''''<summary>
        '''''System.Double
        '''''</summary>
        RefClockRate = 1150020

        '''''<summary>
        '''''System.String
        '''''</summary>
        ExportedRefClockOutputTerminal = 1150072

        '''''<summary>
        '''''System.String
        '''''</summary>
        DigitizerSampleClockTimebaseSource = 1150021

        '''''<summary>
        '''''System.Double
        '''''</summary>
        DigitizerSampleClockTimebaseRate = 1150022

        '''''<summary>
        '''''System.String
        '''''</summary>
        PxiChassisClk10Source = 1150023

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        StartTriggerType = 1150024

        '''''<summary>
        '''''System.String
        '''''</summary>
        DigitalEdgeStartTriggerSource = 1150025

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        DigitalEdgeStartTriggerEdge = 1150026

        '''''<summary>
        '''''System.String
        '''''</summary>
        ExportedStartTriggerOutputTerminal = 1150027

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        RefTriggerType = 1150028

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        RefTriggerPretriggerSamples = 1150035

        '''''<summary>
        '''''System.String
        '''''</summary>
        DigitalEdgeRefTriggerSource = 1150029

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        DigitalEdgeRefTriggerEdge = 1150030

        '''''<summary>
        '''''System.String
        '''''</summary>
        IqPowerEdgeRefTriggerSource = 1150055

        '''''<summary>
        '''''System.Double
        '''''</summary>
        IqPowerEdgeRefTriggerLevel = 1150056

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        IqPowerEdgeRefTriggerSlope = 1150057

        '''''<summary>
        '''''System.Double
        '''''</summary>
        RefTriggerMinimumQuietTime = 1150058

        '''''<summary>
        '''''System.String
        '''''</summary>
        ExportedRefTriggerOutputTerminal = 1150032

        '''''<summary>
        '''''System.Double
        '''''</summary>
        RefTriggerDelay = 1150060

        '''''<summary>
        '''''System.Double
        '''''</summary>
        StartToRefTriggerHoldoff = 1150033

        '''''<summary>
        '''''System.Double
        '''''</summary>
        RefToRefTriggerHoldoff = 1150034

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        AdvanceTriggerType = 1150036

        '''''<summary>
        '''''System.String
        '''''</summary>
        DigitalEdgeAdvanceTriggerSource = 1150037

        '''''<summary>
        '''''System.String
        '''''</summary>
        ExportedAdvanceTriggerOutputTerminal = 1150038

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        ArmRefTriggerType = 1150039

        '''''<summary>
        '''''System.String
        '''''</summary>
        DigitalEdgeArmRefTriggerSource = 1150040

        '''''<summary>
        '''''System.String
        '''''</summary>
        ExportedReadyForStartEventOutputTerminal = 1150041

        '''''<summary>
        '''''System.String
        '''''</summary>
        ExportedReadyForAdvanceEventOutputTerminal = 1150042

        '''''<summary>
        '''''System.String
        '''''</summary>
        ExportedReadyForRefEventOutputTerminal = 1150043

        '''''<summary>
        '''''System.String
        '''''</summary>
        ExportedEndOfRecordEventOutputTerminal = 1150044

        '''''<summary>
        '''''System.Double
        '''''</summary>
        LoFrequency = 1150068

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        DownconverterLoopBandwidth = 1150067

        '''''<summary>
        '''''System.Boolean
        '''''</summary>
        DigitalIfEqualizationEnabled = 1150048

        '''''<summary>
        '''''System.Double
        '''''</summary>
        DownconverterGain = 1150065

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        LoInjectionSide = 1150069

        '''''<summary>
        '''''System.Double
        '''''</summary>
        DigitizerVerticalRange = 1150070

        '''''<summary>
        '''''System.Boolean
        '''''</summary>
        EnableFractionalResampling = 1150071

        '''''<summary>
        '''''System.String
        '''''</summary>
        SerialNumber = 1150053

        '''''<summary>
        '''''System.Double
        '''''</summary>
        DeviceTemperature = 1150051

        '''''<summary>
        '''''System.Double
        '''''</summary>
        TemperatureReadInterval = 1150061

        '''''<summary>
        '''''System.Boolean
        '''''</summary>
        Cache = 1050004

        '''''<summary>
        '''''System.Boolean
        '''''</summary>
        InterchangeCheck = 1050021

        '''''<summary>
        '''''System.String
        '''''</summary>
        DriverSetup = 1050007

        '''''<summary>
        '''''System.Boolean
        '''''</summary>
        QueryInstrumentStatus = 1050003

        '''''<summary>
        '''''System.Boolean
        '''''</summary>
        RangeCheck = 1050002

        '''''<summary>
        '''''System.Boolean
        '''''</summary>
        RecordCoercions = 1050006

        '''''<summary>
        '''''System.Boolean
        '''''</summary>
        Simulate = 1050005

        '''''<summary>
        '''''System.String
        '''''</summary>
        SpecificDriverDescription = 1050514

        '''''<summary>
        '''''System.String
        '''''</summary>
        SpecificDriverPrefix = 1050302

        '''''<summary>
        '''''System.String
        '''''</summary>
        SpecificDriverVendor = 1050513

        '''''<summary>
        '''''System.String
        '''''</summary>
        SpecificDriverRevision = 1050551

        '''''<summary>
        '''''System.String
        '''''</summary>
        SupportedInstrumentModels = 1050327

        '''''<summary>
        '''''System.String
        '''''</summary>
        InstrumentManufacturer = 1050511

        '''''<summary>
        '''''System.String
        '''''</summary>
        InstrumentModel = 1050512

        '''''<summary>
        '''''System.String
        '''''</summary>
        InstrumentFirmwareRevision = 1050510

        '''''<summary>
        '''''System.String
        '''''</summary>
        LogicalName = 1050305

        '''''<summary>
        '''''System.String
        '''''</summary>
        IoResourceDescriptor = 1050304
    End Enum
End Namespace